// STB_Ktools 0.0.2 2009:03:09 06:08:57$
// Copyright (c) 2009 solgracia
// Released under the GNU General Public License
// This code is based on the PP_Channels indicator
// http://www.elitetrader.com/vb/showthread.php?s=e659363d98131d09a36483d3dba21070&threadid=97684&perpage=8&pagenumber=105
// PP_channels.cs and PP_ChartHelper.cs are taken from the submission from LostTrader
// http://www.elitetrader.com/vb/showthread.php?s=e659363d98131d09a36483d3dba21070&threadid=97684&perpage=6&pagenumber=165
// Some code is taken from NinjaPriceAction submitted by TraderGuy
// http://www.ninjatrader-support2.com/vb/local_links.php?action=jump&id=92&catid=1
// The logic is based on the ideas from koolblue
// http://www.mypivots.com/forum/forum.asp?FORUM_ID=26
//  
// 
// Copyright (C) 2006, NinjaTrader LLC <www.ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
using System.Collections.Generic;
using System.Windows.Forms;
#endregion

namespace NinjaTrader.Indicator
{
    [Description("Channel Drawing Tool")]
    public class STB_Ktools : Indicator
    {

        // VARIABLES

        #region Variables

        // COMMON
        private ChartHelper chartHelper;
        private Gtool _currentTool = Gtool.Gline;       // _e_ set graphic tool
        private Gtool _previousTool = Gtool.None;
        private bool _changedTool = false;
        private ToolMode _currentMode = ToolMode.Select;

        private bool _initMouseEvents = false;
        private bool _initMouseEvents_channels = false;
        private bool _initMouseEvents_grects = false;
        private bool _initMouseEvents_glines = false;

        private int fontSize = 12;
        SizeF size;  //graphics.MeasureString("1", f);
        private string _fileName;
        private string _dirName;
        private Point _mouseCurrentPos;

        private string _msgID = "msgWindow";

        protected int _defaultWidth = 1;
        protected Color _defaultColor = Color.Black;
        protected Color _drawingColor = Color.DarkGray;
        protected Color _anchorColor = Color.Black;
        protected Color _snapColor = Color.GreenYellow;
        protected Color _extensionColor = Color.ForestGreen;
        protected bool _binarySerial = false;

        private bool autocolor = false;
        private bool changeDefault = false;
        private bool _initialAlarm = false;
        private string alarm_sound = "Alert2.wav";
        private double prevTick = 0;
        private double prevTrigger = 0;
				
        // CHANNELS
        private string _fileName_channels;

        private Channel _currentChannel = null;

        protected Color _drawingColor_channels = Color.DarkGray;
        protected Color _extensionColor_channels = Color.ForestGreen;
        private string _defaultName_channels = "channel";

        private List<Channel> ChannelList;
        private ChannelLogic channelLogic;

        // GRECTS
        private string _fileName_grects;

        private Grect _currentGrect = null;

        protected Color _drawingColor_grects = Color.DarkBlue;
        protected Color _extensionColor_grects = Color.ForestGreen;
        private string _defaultName_grects = "grect";

        private List<Grect> GrectList;
        private GrectLogic grectLogic;

        // GLINES
        private string _fileName_glines;

        private Gline _currentGline = null;

        protected Color _drawingColor_glines = Color.Orange;
        protected Color _extensionColor_glines = Color.ForestGreen;
        private string _defaultName_glines = "gline";

        private List<Gline> GlineList;
        private GlineLogic glineLogic;

        #endregion

        #region Structs
        public enum Gtool
        {
            None,
            Channel,
            Grect,
            Gline
        };
        public enum ToolMode
        {
            Select,
            Selected,
            Create,
            Edit
        };

        public enum Placement { Top, Bottom };

        #endregion

       // LOCAL

        #region Local Variables

        // Inputs with defaults
        private int swingStrength = 3;	// Default setting for SwingStrength
        private int swingLookback = 50;	// Default lookback period in Bars
        private int swingDtbstrength = 15; 	// Default double top and double bottom strength
        private int swingTextoffset = 50;	// Default setting Text Offset
        // User defined variables
        private int swingPrevHighBarsback;
        private int swingCurHighBarsback;
        private int swingPrevLowBarsback;
        private int swingCurLowBarsback;
        private double swingPrevHighPrice;
        private double swingPrevLowPrice;
        private double swingCurHighPrice;
        private double swingCurLowPrice;
        private double swingOffset;
        private double swingCurATR;
        private double swingToffset;

        protected Color _HHLColor = Color.Green;
        protected Color _LLHColor = Color.Red;

        private int _swingLastHighBarIdx = 0;
        private int _swingLastLowBarIdx = 0;

        private int _swingAtrPeriod = 14;                   // param
        private bool _showSwingTags = false;                     // _e_ param
        private bool _showBarNumbers = false;                     // _e_ param
        private double _strengthBar = 0.3;                     // _e_ param
        private double _strengthMultiplier = 1.0;                     // _e_ param
        private StrengthMode _strengthMode = StrengthMode.kstrength;      // _e_ param
        private bool _shortMode = true;      // _e_ param
        private int _shortRange = 60;      // _e_ param


        public enum StrengthMode
        {
            regdistance,
            pstrength,
            kstrength,
            none
        };

        #endregion Local Variables

        #region Local Overrides
        private void Initialize_local()
        {
            Overlay = true;
            PriceTypeSupported = false;
            CalculateOnBarClose = false;
        }
        private void OnBarUpdate_local()
        {
            if (ChartControl == null) return;
            if (CurrentBar < swingStrength) return;

            if (FirstTickOfBar)
            {
                if (CurrentBar < swingLookback) return;

                if (_shortMode)
                {
                    if (CurrentBar < Bars.Count - _shortRange) return;
                    if (_showBarNumbers) DrawBarNumbers("");
                }

                // H-H
                // _e_ swing highs
                swingPrevHighBarsback = Swing(swingStrength).SwingHighBar(0, 2, swingLookback);
                if (swingPrevHighBarsback == -1) return;
                swingPrevHighPrice = Swing(swingStrength).SwingHigh[swingPrevHighBarsback];

                swingCurHighBarsback = Swing(swingStrength).SwingHighBar(0, 1, swingLookback);
                if (swingCurHighBarsback == -1) return;
                swingCurHighPrice = Swing(swingStrength).SwingHigh[swingCurHighBarsback];

                swingCurATR = ATR(_swingAtrPeriod)[swingCurHighBarsback];
                swingOffset = swingCurATR * swingDtbstrength / 100;
                swingToffset = swingCurATR * swingTextoffset / 100;

                if (_showSwingTags == true)
                {
                    if (swingCurHighPrice < swingPrevHighPrice + swingOffset && swingCurHighPrice > swingPrevHighPrice - swingOffset)
                        DrawText("DT" + CurrentBar, "DT", swingCurHighBarsback, High[swingCurHighBarsback] + swingToffset, Color.Gold);
                    else
                        if (swingCurHighPrice > swingPrevHighPrice)
                            DrawText("HH" + CurrentBar, "HH", swingCurHighBarsback, High[swingCurHighBarsback] + swingToffset, Color.Green);
                        else
                            DrawText("LH" + CurrentBar, "LH", swingCurHighBarsback, High[swingCurHighBarsback] + swingToffset, Color.Red);
                }
                // _e_ highs
                int swingCurHighBarIdx = CurrentBar - swingCurHighBarsback;
                int swingPrevHighBarIdx = CurrentBar - swingPrevHighBarsback;
                if (swingCurHighBarIdx > _swingLastHighBarIdx)                 // Up Trend
                {
                    if (_currentTool == Gtool.Channel)      // _e_ channels
                    {
                        Channel gc = new Channel();
                        chartCoord gc_c1 = new chartCoord();
                        chartCoord gc_c2 = new chartCoord();
                        chartCoord gc_c3 = new chartCoord();
                        chartCoord gc_c4 = new chartCoord();

                        gc.GtoolName = "Channel_" + swingCurHighBarIdx.ToString();
                        gc.ChannelColor = _HHLColor;                        // Look for tough

                        int bb = STB_MIN(Low, swingPrevHighBarsback, swingCurHighBarsback).BarsBack;
                        double bp = Bars.Get(swingPrevHighBarIdx).High;     // previous high bar
                        double ep = Bars.Get(swingCurHighBarIdx).High;     // current high bar
                        double m;           // slope between last two swing lows
                        if (swingCurHighBarsback == swingPrevHighBarsback)  m = 0;
                        else m = (double)(ep - bp) / (swingCurHighBarsback - swingPrevHighBarsback); // PH-CH slope

                        double d = 0;   // price distance betwen swing and time projection
                        if (_strengthMode == StrengthMode.regdistance)
                        {
                            double dl2 = STB_MIN(Low, swingPrevHighBarsback, swingCurHighBarsback)[0];     // min of PH-CH lows
                            d = dl2 - (bp + m * (bb - swingPrevHighBarsback));      // distance PH-CH low to regression
                        }
                        else if (_strengthMode == StrengthMode.pstrength) // min of PH-CH lows
                        {
                            d = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingPrevHighBarsback, swingCurHighBarsback)[0];
                        }
                        else if (_strengthMode == StrengthMode.kstrength)
                        {
                            d = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingCurHighBarsback, 0)[0];
                        }
                        else     //  _strengthMode == StrengthMode.none
                        {
                            d = 0;
                        }

                        double delta = _strengthMultiplier * d;

                        gc_c1.X = Bars.Get(swingCurHighBarIdx).Time;
                        if (ep >= bp) gc_c1.Y = Bars.Get(swingCurHighBarIdx).Low;         // upTrend
                        if (ep < bp) gc_c1.Y = Bars.Get(swingCurHighBarIdx).Low + delta;  // downTrend
                        gc_c1.Valid = true;
                        gc.SetPoint(1, gc_c1, false);

                        gc_c3.X = Bars.Get(swingCurHighBarIdx).Time + (Bars.Get(swingCurHighBarIdx).Time - Bars.Get(swingPrevHighBarIdx).Time);
                        if (ep >= bp) gc_c3.Y = Bars.Get(swingCurHighBarIdx).Low
                            + (Bars.Get(swingCurHighBarIdx).Low - Bars.Get(swingPrevHighBarIdx).Low); // upTrend
                        if (ep < bp) gc_c3.Y = Bars.Get(swingPrevHighBarIdx).Low + delta;        // downTrend
                        gc_c3.Valid = true;
                        gc.SetPoint(3, gc_c3, false);

                        gc_c2.X = gc_c1.X;
                        if (ep >= bp) gc_c2.Y = gc_c1.Y + delta;           // upTrend
                        if (ep < bp) gc_c2.Y = gc_c1.Y - delta;           // downTrend
                        gc.SetPoint(2, gc_c2, false);


                        Insert_channel(gc);
                        _swingLastHighBarIdx = swingCurHighBarIdx;
                    }
                    else if (_currentTool == Gtool.Grect)   // _e_ grects
                    {
                        Grect lh = new Grect();
                        chartCoord lh_c1 = new chartCoord();
                        chartCoord lh_c3 = new chartCoord();
                        chartCoord lh_tmp = new chartCoord();

                        lh.GtoolName = "grect_" + swingCurHighBarIdx.ToString();
                        lh.GrectColor = _HHLColor;

                        lh_c1.X = Bars.Get(swingCurHighBarIdx).Time;
                        lh_c1.Y = Bars.Get(swingCurHighBarIdx).High;
                        lh_c1.Valid = true;
                        lh.SetPoint(1, lh_c1, false);

                        lh_tmp.X = Bars.Get(swingPrevHighBarIdx).Time;
                        lh_tmp.Y = Bars.Get(swingPrevHighBarIdx).High;

                        lh_c3.X = lh_c1.X + (lh_c1.X - lh_tmp.X);   // distance from end point

                        double dh = 1.0;
                        if (_strengthMode == StrengthMode.regdistance)
                        {
                            dh = STB_MIN(Low, swingPrevHighBarsback, swingCurHighBarsback)[0];
                            lh_c3.Y = lh_c1.Y - _strengthMultiplier * (lh_tmp.Y - dh);        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.pstrength)
                        {
                            dh = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingPrevHighBarsback, swingCurHighBarsback)[0];
                            lh_c3.Y = lh_c1.Y + _strengthMultiplier * dh;        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.kstrength)
                        {
                            dh = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingCurHighBarsback, 0)[0];
                            lh_c3.Y = lh_c1.Y + _strengthMultiplier * dh;        // H-H->L
                        }

                        lh_c3.Valid = true;
                        lh.SetPoint(3, lh_c3, false);

                        Insert_grect(lh);
                        _swingLastHighBarIdx = swingCurHighBarIdx;
                    }
                    else if (_currentTool == Gtool.Gline)   // _e_ glines
                    {
                        Gline lh = new Gline();
                        chartCoord lh_c1 = new chartCoord();
                        chartCoord lh_c3 = new chartCoord();
                        chartCoord lh_tmp = new chartCoord();

                        lh.GtoolName = "gline_" + swingCurHighBarIdx.ToString();
                        lh.GlineColor = _HHLColor;

                        lh_c1.X = Bars.Get(swingCurHighBarIdx).Time;
                        lh_c1.Y = Bars.Get(swingCurHighBarIdx).High;
                        lh_c1.Valid = true;
                        lh.SetPoint(1, lh_c1, false);

                        lh_tmp.X = Bars.Get(swingPrevHighBarIdx).Time;
                        lh_tmp.Y = Bars.Get(swingPrevHighBarIdx).High;

                        lh_c3.X = lh_c1.X + (lh_c1.X - lh_tmp.X);   // distance from end point

                        double dh = 1.0;
                        if (_strengthMode == StrengthMode.regdistance)
                        {
                            dh = STB_MIN(Low, swingPrevHighBarsback, swingCurHighBarsback)[0];
                            lh_c3.Y = lh_c1.Y - _strengthMultiplier * (lh_tmp.Y - dh);        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.pstrength)
                        {
                            dh = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingPrevHighBarsback, swingCurHighBarsback)[0];
                            lh_c3.Y = lh_c1.Y + _strengthMultiplier * dh;        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.kstrength)
                        {
                            dh = STB_MIN(STB_TickForce().DownIntegTicksSeries, swingCurHighBarsback, 0)[0];
                            lh_c3.Y = lh_c1.Y + _strengthMultiplier * dh;        // H-H->L
                        }

                        lh_c3.Valid = true;
                        lh.SetPoint(3, lh_c3, false);

                        Insert_gline(lh);
                        _swingLastHighBarIdx = swingCurHighBarIdx;
                    }
                    else
                    {
                        // not gtool created
                    }
                }

                // L-L
                // _e_ vars lows
                swingPrevLowBarsback = Swing(swingStrength).SwingLowBar(0, 2, swingLookback);
                if (swingPrevLowBarsback == -1) return;
                swingPrevLowPrice = Swing(swingStrength).SwingLow[swingPrevLowBarsback];

                swingCurLowBarsback = Swing(swingStrength).SwingLowBar(0, 1, swingLookback);
                if (swingCurLowBarsback == -1) return;
                swingCurLowPrice = Swing(swingStrength).SwingLow[swingCurLowBarsback];

                swingCurATR = ATR(_swingAtrPeriod)[swingCurLowBarsback];
                swingOffset = swingCurATR * swingDtbstrength / 100;
                swingToffset = swingCurATR * swingTextoffset / 100;

                // _e_ text lows
                if (_showSwingTags == true)
                {
                    if (swingCurLowPrice > swingPrevLowPrice - swingOffset && swingCurLowPrice < swingPrevLowPrice + swingOffset)
                        DrawText("DB" + CurrentBar, "DB", swingCurLowBarsback, Low[swingCurLowBarsback] - swingToffset, Color.Gold);
                    else
                        if (swingCurLowPrice < swingPrevLowPrice)
                            DrawText("LL" + CurrentBar, "LL", swingCurLowBarsback, Low[swingCurLowBarsback] - swingToffset, Color.Red);
                        else
                            DrawText("HL" + CurrentBar, "HL", swingCurLowBarsback, Low[swingCurLowBarsback] - swingToffset, Color.Green);
                }

                // _e_ glines L-L
                int swingCurLowBarIdx = CurrentBar - swingCurLowBarsback;
                int swingPrevLowBarIdx = CurrentBar - swingPrevLowBarsback;

                if (swingCurLowBarIdx > _swingLastLowBarIdx)
                {
                    if (_currentTool == Gtool.Channel)
                    {
                            Channel gc = new Channel();
                            chartCoord gc_c1 = new chartCoord();
                            chartCoord gc_c2 = new chartCoord();
                            chartCoord gc_c3 = new chartCoord();
                            chartCoord gc_c4 = new chartCoord();

                            gc.GtoolName = "Channel_" + swingCurLowBarIdx.ToString();
                            gc.ChannelColor = Color.Red;

                            int bb = STB_MAX(High, swingPrevLowBarsback, swingCurLowBarsback).BarsBack;
                            double bp = Bars.Get(swingPrevLowBarIdx).Low;
                            double ep = Bars.Get(swingCurLowBarIdx).Low;
                            double m;       // slope between last two swing lows
                            if (swingCurLowBarsback == swingPrevLowBarsback) m = 0;
                            else m = (double)(ep - bp) / (swingCurLowBarsback - swingPrevLowBarsback);

                            double d = 0;
                            if (_strengthMode == StrengthMode.regdistance)
                            {
                                double dl2 = STB_MAX(High, swingPrevLowBarsback, swingCurLowBarsback)[0];
                                d = dl2 - (bp + m * (bb - swingPrevLowBarsback));
                            }
                            else if (_strengthMode == StrengthMode.pstrength)
                            {
                                d = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingPrevLowBarsback, swingCurLowBarsback)[0];
                            }
                            else if (_strengthMode == StrengthMode.kstrength)
                            {
                                d = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingCurLowBarsback, 0)[0];
                            }
                            else
                            {
                                d = 0;
                            }

                            double delta = _strengthMultiplier * d;

                            gc_c1.X = Bars.Get(swingCurLowBarIdx).Time;
                            if (ep >= bp) gc_c1.Y = Bars.Get(swingCurLowBarIdx).Low;         // upTrend
                            if (ep < bp) gc_c1.Y = Bars.Get(swingCurLowBarIdx).Low + delta;  // downTrend
                            gc_c1.Valid = true;
                            gc.SetPoint(1, gc_c1, false);

                            gc_c3.X = Bars.Get(swingCurLowBarIdx).Time + (Bars.Get(swingCurLowBarIdx).Time - Bars.Get(swingPrevLowBarIdx).Time);
                            if (ep >= bp) gc_c3.Y = Bars.Get(swingCurLowBarIdx).Low
                                + (Bars.Get(swingCurLowBarIdx).Low - Bars.Get(swingPrevLowBarIdx).Low); // upTrend
                            if (ep < bp) gc_c3.Y = Bars.Get(swingPrevLowBarIdx).Low + delta;        // downTrend
                            gc_c3.Valid = true;
                            gc.SetPoint(3, gc_c3, false);

                            gc_c2.X = gc_c1.X;
                            if (ep >= bp) gc_c2.Y = gc_c1.Y + delta;           // upTrend
                            if (ep < bp) gc_c2.Y = gc_c1.Y - delta;           // downTrend
                            gc.SetPoint(2, gc_c2, false);


                            Insert_channel(gc);
                            _swingLastLowBarIdx = swingCurLowBarIdx;
                    }
                    else if (_currentTool == Gtool.Gline)       // glines
                    {

                        Grect ll = new Grect();
                        chartCoord ll_c1 = new chartCoord();
                        Point ll_p1 = new Point();
                        chartCoord ll_c3 = new chartCoord();
                        Point ll_p3 = new Point();

                        ll.GtoolName = "grect_" + swingCurLowBarIdx.ToString();
                        ll.GrectColor = _LLHColor;

                        ll_c1.X = Bars.Get(swingCurLowBarIdx).Time;
                        ll_c1.Y = Bars.Get(swingCurLowBarIdx).Low;
                        ll_c1.Valid = true;
                        ll.SetPoint(1, ll_c1, false);

                        ll_c3.X = Bars.Get(swingPrevLowBarIdx).Time;
                        ll_c3.Y = Bars.Get(swingPrevLowBarIdx).Low;

                        ll_c3.X = ll_c1.X + (ll_c1.X - ll_c3.X);

                        double dl = 1.0;
                        if (_strengthMode == StrengthMode.regdistance)
                        {
                            dl = STB_MAX(High, swingPrevLowBarsback, swingCurLowBarsback)[0];
                            ll_c3.Y = ll_c1.Y - _strengthMultiplier * (ll_c3.Y - dl);        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.pstrength)
                        {
                            dl = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingPrevLowBarsback, swingCurLowBarsback)[0];
                            ll_c3.Y = ll_c1.Y + _strengthMultiplier * dl;        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.kstrength)
                        {
                            dl = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingCurLowBarsback, 0)[0];
                            ll_c3.Y = ll_c1.Y + _strengthMultiplier * dl;        // H-H->L
                        }

                        ll_c3.Valid = true;
                        ll.SetPoint(3, ll_c3, false);

                        Insert_grect(ll);
                        _swingLastLowBarIdx = swingCurLowBarIdx;
                    }
                    else if (_currentTool == Gtool.Gline)       // glines
                    {

                        Gline ll = new Gline();
                        chartCoord ll_c1 = new chartCoord();
                        Point ll_p1 = new Point();
                        chartCoord ll_c3 = new chartCoord();
                        Point ll_p3 = new Point();

                        ll.GtoolName = "gline_" + swingCurLowBarIdx.ToString();
                        ll.GlineColor = _LLHColor;

                        ll_c1.X = Bars.Get(swingCurLowBarIdx).Time;
                        ll_c1.Y = Bars.Get(swingCurLowBarIdx).Low;
                        ll_c1.Valid = true;
                        ll.SetPoint(1, ll_c1, false);

                        ll_c3.X = Bars.Get(swingPrevLowBarIdx).Time;
                        ll_c3.Y = Bars.Get(swingPrevLowBarIdx).Low;

                        ll_c3.X = ll_c1.X + (ll_c1.X - ll_c3.X);

                        double dl = 1.0;
                        if (_strengthMode == StrengthMode.regdistance)
                        {
                            dl = STB_MAX(High, swingPrevLowBarsback, swingCurLowBarsback)[0];
                            ll_c3.Y = ll_c1.Y - _strengthMultiplier * (ll_c3.Y - dl);        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.pstrength)
                        {
                            dl = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingPrevLowBarsback, swingCurLowBarsback)[0];
                            ll_c3.Y = ll_c1.Y + _strengthMultiplier * dl;        // H-H->L
                        }
                        else if (_strengthMode == StrengthMode.kstrength)
                        {
                            dl = STB_MAX(STB_TickForce().UpIntegTicksSeries, swingCurLowBarsback, 0)[0];
                            ll_c3.Y = ll_c1.Y + _strengthMultiplier * dl;        // H-H->L
                        }

                        ll_c3.Valid = true;
                        ll.SetPoint(3, ll_c3, false);

                        Insert_gline(ll);
                        _swingLastLowBarIdx = swingCurLowBarIdx;
                    }
                    else
                    {
                        // no gtool selected
                    }
                }
            }

        }
        private void Plot_local()
        {
        }

        #endregion Local Overrides

        // OVERRIDES

        #region OVERRIDES

        protected override void Initialize()
        {
            CalculateOnBarClose = false;
            Overlay = true;
            PriceTypeSupported = false;

            chartHelper = new ChartHelper(ChartControl, Bars, TickSize);
            channelLogic = new ChannelLogic(Bars, chartHelper, _binarySerial);
            grectLogic = new GrectLogic(Bars, chartHelper, _binarySerial);
            glineLogic = new GlineLogic(Bars, chartHelper, _binarySerial);

            Initialize_local();            // _e_
        }

        // .....................    OnBarUpdate
        protected override void OnBarUpdate()
        {
            // 			
            if (CalculateOnBarClose != false)
                CalculateOnBarClose = false;

            //if (Bars.MarketData == null) Print("Currently a connection is required");

            if ((ChartControl != null) && (!_initMouseEvents))
            {
                this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_SelectGtool);
            }

            OnBarUpdate_onstart_channels();
            OnBarUpdate_onstart_grects();
            OnBarUpdate_onstart_glines();
            _initMouseEvents = true;

            OnBarUpdate_onchange_channels();
            OnBarUpdate_onchange_grects();
            OnBarUpdate_onchange_glines();
            _changedTool = false;

            OnBarUpdate_local();            // _e_
        }

        // .....................    Plot
        public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
        {
            //base.Plot (graphics, bounds, min, max); 
            chartHelper.Update(bounds, min, max);
            Plot_channels(graphics, bounds, min, max);      // _e_
            Plot_grects(graphics, bounds, min, max);      // _e_
            Plot_glines(graphics, bounds, min, max);      // _e_

            Plot_local();        // _e_

        }

        #endregion

        // CHANNELS

        #region CHANNEL OVERRIDES

        // .....................    OnBarUpdate_onstart_channels
        protected void OnBarUpdate_onstart_channels()
        {
            if ((ChartControl != null) && (!_initMouseEvents))
            {
                if (_currentTool == Gtool.Channel)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_channels);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_channels);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_channels);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_channels);

                }
                _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                if (!Directory.Exists(_dirName))
                    Directory.CreateDirectory(_dirName);

                _fileName_channels = _dirName + Instrument.FullName + "_" + "channels" + "_" + Bars.Period.Value + ".dat";

                ChannelList = channelLogic.DeserializeChannels(_fileName_channels, Bars.Get(0).Time);
                if (_currentTool == Gtool.Channel)
                {
                    _fileName = _fileName_channels;
                }
            }
        }

        // .....................    OnBarUpdate_onchange_channels
        protected void OnBarUpdate_onchange_channels()
        {
            if (_changedTool == true)
            {
                if (_previousTool == Gtool.Channel)
                {
                    this.ChartControl.ChartPanel.MouseDown -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_channels);
                    this.ChartControl.ChartPanel.MouseMove -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_channels);
                    this.ChartControl.ChartPanel.KeyDown -= new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_channels);
                    this.ChartControl.ChartPanel.Paint -= new System.Windows.Forms.PaintEventHandler(this.chart_Paint_channels);
                }

                if (_currentTool == Gtool.Channel)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_channels);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_channels);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_channels);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_channels);

                    _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                    if (!Directory.Exists(_dirName))
                        Directory.CreateDirectory(_dirName);

                    _fileName_channels = _dirName + Instrument.FullName + "_" + "channels" + "_" + Bars.Period.Value + ".dat";

                    ChannelList = channelLogic.DeserializeChannels(_fileName_channels, Bars.Get(0).Time);

                        _fileName = _fileName_channels;     // _e_

                }
            }
        }

        // .....................    Plot_channels
        public void Plot_channels(Graphics graphics, Rectangle bounds, double min, double max)
        {
            //base.Plot (graphics, bounds, min, max); 
            chartHelper.Update(bounds, min, max);
            int cc = 0;

            // if (ChannelList != null)  
            lock (ChannelList)
            {
                // Draw Channels			
                for (int i = 0; i < ChannelList.Count; i++)
                    if (ChannelList[i].ReadyToDraw)
                    {
                        cc++;
                        channelLogic.DrawChannel(graphics, ChannelList[i], ChannelList[i].ChannelColor, ChannelList[i].ChannelWidth);

                        if (ChannelList[i].Numbers)
                        {
                            Color test = ChannelList[i].ChannelColor;
                            SolidBrush brushN = new SolidBrush(test);
                            int thisFont = fontSize + 3 * ChannelList[i].ChannelWidth;
                            Font f = new Font("Arial", thisFont, FontStyle.Bold, GraphicsUnit.Pixel);
                            size = graphics.MeasureString("1", f);

                            int space1;
                            int space2;
                            if (ChannelList[i].ChartP1.Y < ChannelList[i].ChartP2.Y)
                            {
                                space1 = Convert.ToInt16(Math.Round(0.4 * size.Height));
                                space2 = -Convert.ToInt16(Math.Round(1.4 * size.Height));
                            }
                            else
                            {
                                space1 = -Convert.ToInt16(Math.Round(1.4 * size.Height));
                                space2 = Convert.ToInt16(Math.Round(0.4 * size.Height));
                            }

                            float y = chartHelper.ConvertPriceToY(ChannelList[i].ChartP1.Y) + space1;
                            int baridx = Bars.GetBar((ChannelList[i].ChartP1.X));
                            int x = ChartControl.GetXByBarIdx(baridx) - Convert.ToInt16(0.4 * size.Width);
                            PointF NumPoint1 = new PointF(x, y);
                            graphics.DrawString("1", f, brushN, NumPoint1);

                            y = chartHelper.ConvertPriceToY(ChannelList[i].ChartP2.Y) + space2;
                            baridx = Bars.GetBar((ChannelList[i].ChartP2.X));
                            x = ChartControl.GetXByBarIdx(baridx) - Convert.ToInt16(0.4 * size.Width);
                            PointF NumPoint2 = new PointF(x, y);
                            graphics.DrawString("2", f, brushN, NumPoint2);

                            y = chartHelper.ConvertPriceToY(ChannelList[i].ChartP3.Y) + space1;
                            baridx = Bars.GetBar((ChannelList[i].ChartP3.X));
                            x = ChartControl.GetXByBarIdx(baridx) - Convert.ToInt16(0.4 * size.Width);
                            PointF NumPoint3 = new PointF(x, y);
                            graphics.DrawString("3", f, brushN, NumPoint3);

                            //Print("-- Numbers on: " + cc);
                        }

                        if (ChannelList[i].Alarm)
                        {
                            int x = ChartControl.GetXByBarIdx(CurrentBar);   //canvas point int x 
                            double y1 = (ChannelList[i].ChartP1.Y);
                            int baridx1 = Bars.GetBar((ChannelList[i].ChartP1.X));		// only works if P1 <= CurrentBar
                            double y3 = (ChannelList[i].ChartP3.Y);
                            int baridx3 = chartHelper.ConvertTimeToIdx((ChannelList[i].ChartP3.X));
                            double slope = (double)(y3 - y1) / (double)(baridx3 - baridx1);

                            //double slope = channelLogic.Slope( ChannelList[i] );
                            double currenty = slope * (CurrentBar - baridx1) + y1;	// the trigger value										

                            Color textcolor = ChannelList[i].ChannelColor;				// set up the text font
                            Font f = new Font("Arial", 11, FontStyle.Bold, GraphicsUnit.Pixel);
                            size = graphics.MeasureString("1", f);
                            Color backColor = Color.Empty;
                            if (ChartControl != null) backColor = ChartControl.BackColor;

                            string alarm_msg = "[" + Bars.Period.Value.ToString() + " " + Bars.Period.Id.ToString() + "] RTL Breach @ " + Close[0].ToString();
                            string alarm_tag = "RTLAlert" + i.ToString() + "_" + CurrentBar.ToString();

                            SolidBrush brushN = new SolidBrush(textcolor); // for on-chart use
                            //if (y3 > y1 ) 					
                            if (channelLogic.UpTrend(ChannelList[i]))
                            {
                                float y = chartHelper.ConvertPriceToY(currenty) + (size.Height);
                                PointF NumPoint3 = new PointF(x, y);
                                graphics.DrawString("RTL Alert @ " + Math.Round(currenty, 2).ToString(), f, brushN, NumPoint3);

                                //if ( (Close[0] < currenty) && (prevTick >= prevTrigger) )   // cross below an UP RTL
                                if ((Close[0] < currenty))
                                {
                                    Alert(alarm_tag, NinjaTrader.Cbi.Priority.High, alarm_msg, alarm_sound, 10, backColor, textcolor);
                                    ChannelList[i].Alarm = false;    // we triggered so now disable (don't want to be annoying)
                                    channelLogic.SerializeChannels(ChannelList, _fileName);
                                }
                            }
                            else //if (y3 < y1) 
                            {
                                float y = chartHelper.ConvertPriceToY(currenty) - 2 * (size.Height);
                                PointF NumPoint3 = new PointF(x, y);
                                graphics.DrawString("RTL Alert @ " + Math.Round(currenty, 2).ToString(), f, brushN, NumPoint3);

                                //if ( (Close[0] > currenty) && (prevTick <= prevTrigger) )   // cross above a Down RTL	
                                if ((Close[0] > currenty))
                                {
                                    Alert(alarm_tag, NinjaTrader.Cbi.Priority.High, alarm_msg, alarm_sound, 10, backColor, textcolor);
                                    ChannelList[i].Alarm = false;    // we triggered so now disable (don't want to be annoying)
                                    channelLogic.SerializeChannels(ChannelList, _fileName);
                                }
                            }
                            /*Print("-- Alarm on: " + cc + " slope=" + Math.Round(slope,2).ToString() 
                                    + " P3=" + baridx3.ToString() + " " + ChannelList[i].ChartP3.X.ToString() 
                                    + " C=" + prevTick.ToString() + " Tr=" + prevTrigger.ToString() );  */
                            prevTrigger = currenty;
                            prevTick = Close[0];
                        }   //  Alarm IF routine				
                    }		// ChannelList FOR loop		
            }  // lock() bracket			
            //Print ("Plotting: Channel Count =" + cc);
        }		

        #endregion CHANNEL OVERRIDES

        #region Channel Logic
        public class ChannelLogic
        {
            string _debug = "";
            private Bars Bars;
            private ChartHelper chartHelper;
            private bool _enableBinarySerialization;

            #region Initialization
            public ChannelLogic(Bars ntBars, ChartHelper charthelper, bool enableBinarySerialization)
            {
                Bars = ntBars;
                chartHelper = charthelper;
            }

            public string GetDebugInfo()
            {
                return _debug;
            }
            #endregion

            #region Serialization
            public void SerializeChannels(List<Channel> channels, string file)
            {
                lock (channels)
                {
                    if (_enableBinarySerialization)
                        SaveChannelList(channels, file);
                    else
                        SaveChannelListXML(channels, file);
                }
            }
            public List<Channel> DeserializeChannels(string file, DateTime startTime)
            {
                if (_enableBinarySerialization)
                    return ReadChannelList(file, startTime);

                return ReadChannelListXML(file, startTime);
            }

            protected void SaveChannelListXML(List<Channel> channels, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";

                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Channel>));
                    serializer.Serialize(stream, channels);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {

                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }

            protected List<Channel> ReadChannelListXML(string file, DateTime startTime)
            {
                _debug = "";

                List<Channel> channels = new List<Channel>();
                Channel channel;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return channels;

                _debug = "Open File Ok\r\n";
                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Channel>));
                    _debug += "Try to deserialize\r\n";
                    channels = (List<Channel>)serializer.Deserialize(stream);
                    _debug += "Channel Count=" + channels.Count + "\r\n";
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(channels, startTime);

                return channels;
            }

            protected void SaveChannelList(List<Channel> channels, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();

                    formatter.Serialize(stream, channels);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {
                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }
            protected List<Channel> ReadChannelList(string file, DateTime startTime)
            {
                _debug = "";

                List<Channel> channels = new List<Channel>();
                Channel channel;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return channels;

                _debug = "Open File Ok\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();
                    _debug += "Try to deserialize\r\n";
                    channels = (List<Channel>)formatter.Deserialize(stream);
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(channels, startTime);

                return channels;
            }

            public void VerifyVisibility(List<Channel> channels, DateTime startTime)
            {
                for (int i = 0; i < channels.Count; i++)
                {
                    if (channels[i].ChartP1.X <= startTime)
                        channels[i].ReadyToDraw = false;
                    else
                        channels[i].ReadyToDraw = true;
                }
            }

            #endregion

            #region Snap

            public chartCoord Snap(Graphics graphics, chartCoord coord, Color color)
            {
                Point pntTest;
                Rectangle rectPoint;
                chartCoord retCoord = coord;

                int size = 8;

                Point pnt = chartHelper.CalcCanvasCoordFromChartCoords(coord);
                rectPoint = new Rectangle(pnt.X - (size / 2), pnt.Y - (size / 2), size, size);

                int barIdx = chartHelper.GetBarIdxFromChartCoord(coord);
                if ((barIdx < 0) && (barIdx >= Bars.Count))
                    return retCoord;

                for (int idx = barIdx - 1; idx < barIdx + 1; idx++)
                {
                    chartCoord coordHigh;
                    coordHigh.X = Bars.Get(idx).Time;
                    coordHigh.Y = Bars.Get(idx).High;
                    coordHigh.Valid = true;

                    chartCoord coordLow;
                    coordLow.X = Bars.Get(idx).Time;
                    coordLow.Y = Bars.Get(idx).Low;
                    coordLow.Valid = true;

                    pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordHigh);
                    rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);

                    if (rectPoint.Contains(pnt))
                    {
                        retCoord = coordHigh;
                        DrawSnap(graphics, rectPoint, color);
                        break;
                    }
                    else
                    {
                        pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordLow);
                        rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);
                        if (rectPoint.Contains(pnt))
                        {
                            retCoord = coordLow;
                            DrawSnap(graphics, rectPoint, color);
                            break;
                        }
                    }
                }

                return retCoord;
            }

            public void DrawSnap(Graphics graphics, Rectangle rect, Color color)
            {
                if (graphics == null)
                    return;

                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;

                graphics.FillRectangle(new SolidBrush(color), rect);

                graphics.SmoothingMode = oldSmoothingMode;
            }
            #endregion

            #region Trend Lines
            public bool UpTrend(Channel channel)
            {
                if (channel.ChartP3.Y > channel.ChartP1.Y)
                    return true;

                else return false;
            }

            public double Slope(Channel channel)
            {
                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP1);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP3);
                LineEx RTL = new LineEx(P1, P3);
                return RTL.LineSlope();
            }

            public int CalcPt2BarIdx(Channel channel)
            {
                int barIdx = 0;

                if ((channel.ChartP4.X <= channel.ChartP1.X)) 	// why would P4 be to the left of P1 ??
                    return chartHelper.GetBarIdxFromChartCoord(channel.ChartP3);

                //Get bar index of most extreme bar between pt1 and pt3
                if (UpTrend(channel))
                    barIdx = GetBarIdxExtreme(channel.ChartP1, channel.ChartP3, true);
                else
                    barIdx = GetBarIdxExtreme(channel.ChartP1, channel.ChartP3, false);

                return barIdx;
            }

            public int GetBarIdxExtreme(chartCoord startCoord, chartCoord endCoord, bool highs)
            {
                chartCoord coord;
                chartCoord coordTest;
                Point pnt;
                LineEx paralell;

                int startBar = chartHelper.GetBarIdxFromChartCoord(startCoord);
                int endBar = chartHelper.GetBarIdxFromChartCoord(endCoord);

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(startCoord);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(endCoord);
                LineEx RTL = new LineEx(P1, P3);

                if (P1.X == 0)
                    return 0;

                int idx = startBar;
                do
                {
                    pnt = chartHelper.GetCanvasCoordBarIndex(idx, highs);
                    paralell = RTL.CreateParalell(pnt);

                    int i;
                    for (i = (idx + 1); i <= endBar; i++)
                    {
                        pnt = chartHelper.GetCanvasCoordBarIndex(i, highs);
                        if (paralell.IsPointOutOfLine(pnt, highs))
                            break;
                    }

                    if (i >= endBar)
                        break;

                    idx++;
                } while (idx <= (endBar));

                return idx;
            }

            public List<LineEx> CalcVEs(chartCoord startCoord, chartCoord point2, chartCoord point3, chartCoord endCoord, bool highs)
            {
                List<LineEx> ltls = new List<LineEx>();
                _debug = "";

                chartCoord coord;
                chartCoord coordTest;
                Point pnt1;
                Point pnt2;
                LineEx paralell;

                int startBar = chartHelper.GetBarIdxFromChartCoord(startCoord);
                int endBar = chartHelper.GetBarIdxFromChartCoord(endCoord);
                int Pt2Bar = chartHelper.GetBarIdxFromChartCoord(point2);

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(startCoord);
                Point P2 = chartHelper.CalcCanvasCoordFromChartCoords(point2);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(point3);
                Point P4 = chartHelper.CalcCanvasCoordFromChartCoords(endCoord);

                if (P2.X == 0)
                    return ltls;

                LineEx RTL = new LineEx(P1, P3);
                RTL.ExtendLine(P4.X);

                paralell = RTL.CreateParalell(P2);

                int idx = Pt2Bar;
                do
                {
                    int i;
                    for (i = (idx + 1); i <= endBar; i++)
                    {
                        pnt1 = chartHelper.GetCanvasCoordBarIndex(i, highs);
                        //	_debug +=  "Pnt1=" + pnt1.ToString () + " \r\n";
                        if (paralell.IsPointOutOfLine(pnt1, highs))
                            break;
                    }

                    if (i > endBar)
                    {
                        ltls.Add(paralell);
                        break;
                    }
                    else
                    {
                        pnt1 = chartHelper.GetCanvasCoordBarIndex(i, highs);
                        paralell.ExtendLine(pnt1.X);
                        ltls.Add(paralell);
                        paralell = RTL.CreateParalell(pnt1);
                    }

                    idx++;
                } while (idx <= endBar);

                return ltls;
            }

            public List<LineEx> CreateTrendlines(Channel channel)
            {
                string ss = "";

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP1);
                Point P2 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP2);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP3);
                Point P4 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP4);

                List<LineEx> TrendLines = new List<LineEx>();

                if (P1.X == 0)
                    return TrendLines;

                if (P1 == P3)
                    return TrendLines;

                // RTL
                LineEx RTL = new LineEx(P1, P3);
                RTL.ExtendLine(P4.X);
                TrendLines.Insert(0, RTL);

                if (channel.PointsCount > 2)
                {
                    List<LineEx> ltls = CalcVEs(channel.ChartP1, channel.ChartP2, channel.ChartP3, channel.ChartP4, UpTrend(channel));
                    foreach (LineEx line in ltls)
                        TrendLines.Add(line);
                }
                else
                {
                    LineEx LTL = RTL.CreateParalell(P2);
                    TrendLines.Add(LTL);
                }

                //				//Calc and update channel extension point
                //				int max = TrendLines.Count-1 ;
                //				Point extensionPnt = new Point (TrendLines[max].P2.X, TrendLines[max].P2.Y); 
                //				chartCoord extPntChart = chartHelper.CalcChartCoordFromCanvasCoord (extensionPnt.X, extensionPnt.Y);
                //				channel.SetPoint(4, extPntChart, true);

                return TrendLines;
            }

            #endregion

            #region Drawing Channels

            public void DrawChannel(Graphics graphics, Channel channel)
            {
                List<LineEx> TrendLines = CreateTrendlines(channel);
                Draw(graphics, TrendLines, channel.ChannelColor, channel.ChannelWidth);
            }
            public void DrawChannel(Graphics graphics, Channel channel, Color color, int width)
            {
                List<LineEx> TrendLines = CreateTrendlines(channel);
                Draw(graphics, TrendLines, color, width);
                //if (channel.Numbers) DrawNumbers(graphics,channel);

            }
            protected void Draw(Graphics graphics, List<LineEx> TrendLines, Color color, int width)
            {
                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;
                Pen pen = new Pen(color, width);
                for (int i = 0; i < TrendLines.Count; i++)
                    graphics.DrawLine(pen, TrendLines[i].P1, TrendLines[i].P2);

                graphics.SmoothingMode = oldSmoothingMode;
            }


            #endregion

            #region Selection
            public bool IsInLine(Channel channel, Point pnt)
            {
                List<LineEx> TrendLines = CreateTrendlines(channel);

                Pen p = new Pen(Color.Black, 8);
                GraphicsPath pth = new GraphicsPath();

                for (int i = 0; i < TrendLines.Count; i++)
                {
                    pth.Reset();

                    if (TrendLines[i].P1 != TrendLines[i].P2)
                    {
                        pth.AddLine(TrendLines[i].P1, TrendLines[i].P2);
                        pth.Widen(p);

                        if (pth.IsVisible(pnt))
                        {
                            p.Dispose();
                            return true;
                        }
                    }
                }
                p.Dispose();
                return false;
            }

            public Rectangle[] CalcAnchorPoints(Channel channel)
            {
                Point pnt;
                Size sz = new Size(6, 6);
                Rectangle[] rectAnchor = new Rectangle[4];

                List<LineEx> TrendLines = CreateTrendlines(channel);

                //P1
                pnt = new Point(TrendLines[0].P1.X - 3, TrendLines[0].P1.Y - 3);
                rectAnchor[0] = new Rectangle(pnt, sz);
                //P3
                pnt = new Point(TrendLines[0].P2.X - 3, TrendLines[0].P2.Y - 3);
                rectAnchor[2] = new Rectangle(pnt, sz);
                //P2
                pnt = new Point(TrendLines[1].P1.X - 3, TrendLines[1].P1.Y - 3);
                rectAnchor[1] = new Rectangle(pnt, sz);

                //Extension Point
                int max = TrendLines.Count - 1;
                pnt = new Point(TrendLines[max].P2.X - 4, TrendLines[max].P2.Y - 4);
                rectAnchor[3] = new Rectangle(pnt, new Size(8, 8));

                return rectAnchor;
            }

            public int IsInAnchorPoint(Rectangle[] rectAnchor, Point pnt)
            {
                int AnchorPointSelected = 0;

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }
                return AnchorPointSelected;
            }

            public int IsInAnchorPoint(Channel channel, Point pnt)
            {
                int AnchorPointSelected = 0;

                if (!channel.IsSelected)
                    return AnchorPointSelected;

                Rectangle[] rectAnchor = CalcAnchorPoints(channel);

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }

                return AnchorPointSelected;
            }

            public void DrawAnchor(Graphics graphics, int point, Color color, bool inflate, Rectangle[] rectAnchor)
            {
                Rectangle rect;

                if (inflate)
                    rect = Rectangle.Inflate(rectAnchor[point - 1], 1, 1);
                else
                    rect = rectAnchor[point - 1];

                if (point < 4)
                    graphics.FillRectangle(new SolidBrush(color), rect);
                else
                    graphics.FillEllipse(new SolidBrush(color), rect);
            }

            public Rectangle[] Select(Graphics graphics, Channel channel, Color anchorColor, Color extensionColor)
            {
                Rectangle[] anchors = CalcAnchorPoints(channel);

                DrawAnchor(graphics, 1, anchorColor, false, anchors);
                DrawAnchor(graphics, 2, anchorColor, false, anchors);
                DrawAnchor(graphics, 3, anchorColor, false, anchors);

                DrawAnchor(graphics, 4, extensionColor, false, anchors);
                channel.IsSelected = true;
                return anchors;
            }

            public void DeSelect(Channel channel)
            {
                channel.IsSelected = false;
                channel.AnchorPointSelected = 0;
            }

            #endregion

            #region Cancel Points
            public void SetCancelPoint(Channel channel, int point)
            {
                if (point == 1) { channel.prevPointCoord = channel.ChartP1; }
                if (point == 2) { channel.prevPointCoord = channel.ChartP2; }
                if (point == 3) { channel.prevPointCoord = channel.ChartP3; }

                channel.CancelPoint = point;
            }
            public void CancelPoint(Channel channel)
            {
                if (channel.CancelPoint == 0)
                    return;

                if (channel.CancelPoint == 1) { channel.ChartP1 = channel.prevPointCoord; }
                if (channel.CancelPoint == 2) { channel.ChartP2 = channel.prevPointCoord; }
                if (channel.CancelPoint == 3) { channel.ChartP3 = channel.prevPointCoord; }
            }
            #endregion


        }
        #endregion				

        #region Channel
        [Serializable()]
        public class Channel : ISerializable
        {
            // Private properties:
            private Color _channelColor;

            //Public properties:

            // Serialization properties
            public string GtoolName;      // _e_
            public bool Numbers;   //** palinuro's additions
            public bool Alarm;  //** palinuro's additions
            public int PointsCount;
            public bool ReadyToDraw;
            public chartCoord ChartP1;
            public chartCoord ChartP2;
            public chartCoord ChartP3;
            public chartCoord ChartP4;
            public int ChannelWidth;
            public int ChannelColorSerialize
            {
                get { return _channelColor.ToArgb(); }
                set { _channelColor = Color.FromArgb(value); }
            }
            // End

            [XmlIgnore()]
            public Color ChannelColor
            {
                get { return _channelColor; }
                set { _channelColor = value; }
            }

            [XmlIgnore()]
            [NonSerialized()]
            public bool IsSelected = false;
            [XmlIgnore()]
            [NonSerialized()]
            public int AnchorPointSelected = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public int CancelPoint = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public chartCoord prevPointCoord;

            public Channel()
            {
                PointsCount = 0;
                ReadyToDraw = false;
                Numbers = false; // _Palinuro_
                Alarm = false; // _Palinuro_
            }

            public void ResetPoints()
            {
                PointsCount = 0;
            }

            public void SetPoint(int id, chartCoord coord, bool noCount)
            {
                if (id == 1) ChartP1 = coord;
                if (id == 2) ChartP2 = coord;
                if (id == 3) { ChartP3 = coord; ChartP4 = coord; }
                if (id == 4) ChartP4 = coord;

                if (!noCount)
                    PointsCount++;
            }
            public void SetPoint(int id, DateTime barX, double price, bool noCount)
            {
                if (id == 1) { ChartP1.X = barX; ChartP1.Y = price; }
                if (id == 2) { ChartP2.X = barX; ChartP2.Y = price; }
                if (id == 3) { ChartP3.X = barX; ChartP3.Y = price; ChartP4.X = barX; ChartP4.Y = price; }
                if (id == 4) { ChartP4.X = barX; ChartP4.Y = price; }

                if (!noCount)
                    PointsCount++;
            }

            #region "Binary Serialization"
            // Used only for Binary Serialization
            public Channel(SerializationInfo info, StreamingContext ctxt)
            {
                //Get the values from info and assign them to the appropriate properties
                GtoolName = (string)info.GetValue("GtoolName", typeof(string));    // _e_
                Numbers = (bool)info.GetValue("Numbers", typeof(bool));	//**
                Alarm = (bool)info.GetValue("Alarm", typeof(bool));	//**
                PointsCount = (int)info.GetValue("PointsCount", typeof(int));
                ReadyToDraw = (bool)info.GetValue("ReadyToDraw", typeof(bool));
                ChartP1.X = (DateTime)info.GetValue("ChartP1.X", typeof(DateTime));
                ChartP1.Y = (double)info.GetValue("ChartP1.Y", typeof(double));
                ChartP1.Valid = (bool)info.GetValue("ChartP1.Valid", typeof(bool));
                ChartP2.X = (DateTime)info.GetValue("ChartP2.X", typeof(DateTime));
                ChartP2.Y = (double)info.GetValue("ChartP2.Y", typeof(double));
                ChartP2.Valid = (bool)info.GetValue("ChartP2.Valid", typeof(bool));
                ChartP3.X = (DateTime)info.GetValue("ChartP3.X", typeof(DateTime));
                ChartP3.Y = (double)info.GetValue("ChartP3.Y", typeof(double));
                ChartP3.Valid = (bool)info.GetValue("ChartP3.Valid", typeof(bool));
                ChartP4.X = (DateTime)info.GetValue("ChartP4.X", typeof(DateTime));
                ChartP4.Y = (double)info.GetValue("ChartP4.Y", typeof(double));
                ChartP4.Valid = (bool)info.GetValue("ChartP4.Valid", typeof(bool));
                ChannelWidth = (int)info.GetValue("ChannelWidth", typeof(int));
                ChannelColor = (Color)info.GetValue("ChannelColor", typeof(Color));
            }

            //Serialization function.
            public void GetObjectData(SerializationInfo info, StreamingContext ctxt)
            {
                //You can use any custom name for your name-value pair. But make sure you
                // read the values with the same name. For ex:- If you write EmpId as "EmployeeId"
                // then you should read the same with "EmployeeId"
                info.AddValue("GtoolName", GtoolName); // _e_
                info.AddValue("Numbers", Numbers);  //** tg
                info.AddValue("Alarm", Alarm);    //** tg
                info.AddValue("PointsCount", PointsCount);
                info.AddValue("ReadyToDraw", ReadyToDraw);
                info.AddValue("ChartP1.X", ChartP1.X);
                info.AddValue("ChartP1.Y", ChartP1.Y);
                info.AddValue("ChartP1.Valid", ChartP1.Valid);
                info.AddValue("ChartP2.X", ChartP2.X);
                info.AddValue("ChartP2.Y", ChartP2.Y);
                info.AddValue("ChartP2.Valid", ChartP2.Valid);
                info.AddValue("ChartP3.X", ChartP3.X);
                info.AddValue("ChartP3.Y", ChartP3.Y);
                info.AddValue("ChartP3.Valid", ChartP3.Valid);
                info.AddValue("ChartP4.X", ChartP4.X);
                info.AddValue("ChartP4.Y", ChartP4.Y);
                info.AddValue("ChartP4.Valid", ChartP4.Valid);
                info.AddValue("ChannelWidth", ChannelWidth);
                info.AddValue("ChannelColor", ChannelColor);
            }
            #endregion
        }
        #endregion

        #region Methods CHANNEL
        // .....................    chart_Paint_channels
        public void chart_Paint_channels(object sender, PaintEventArgs e)
        {
            chartHelper.chartControl = ChartControl;

            if (_currentMode == ToolMode.Select)
                return;

            try
            {
                if (_currentMode == ToolMode.Create)
                {
                    if ((_mouseCurrentPos != Point.Empty) || (_currentChannel != null))
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = channelLogic.Snap(e.Graphics, coord, _snapColor);

                        if (!_currentChannel.ChartP1.Valid)
                            return;

                        _currentChannel.SetPoint(3, coord, true);
                        int barpt2idx = channelLogic.CalcPt2BarIdx(_currentChannel);

                        bool upTrend = channelLogic.UpTrend(_currentChannel);
                        chartCoord chartCoord = chartHelper.GetChartCoordBarIndex(barpt2idx, upTrend);
                        if (!chartCoord.Valid) return;
                        _currentChannel.SetPoint(2, chartCoord, true);

                        channelLogic.DrawChannel(e.Graphics, _currentChannel, _drawingColor_channels, 1);
                    }
                }
                else if ((_currentMode == ToolMode.Selected))
                {

                    Rectangle[] anchors = channelLogic.Select(e.Graphics, _currentChannel, _anchorColor, _extensionColor_channels);

                    _currentChannel.AnchorPointSelected = channelLogic.IsInAnchorPoint(anchors, new Point(_mouseCurrentPos.X, _mouseCurrentPos.Y));
                    if (_currentChannel.AnchorPointSelected > 0 && _currentChannel.AnchorPointSelected < 4)
                        channelLogic.DrawAnchor(e.Graphics, _currentChannel.AnchorPointSelected, _anchorColor, true, anchors);
                    else if (_currentChannel.AnchorPointSelected == 4)
                        channelLogic.DrawAnchor(e.Graphics, _currentChannel.AnchorPointSelected, _extensionColor_channels, true, anchors);
                }
                else if (_currentMode == ToolMode.Edit)
                {
                    if ((_mouseCurrentPos != Point.Empty) || (_currentChannel != null))
                    {
                        _currentChannel.ReadyToDraw = false;

                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = channelLogic.Snap(e.Graphics, coord, _snapColor);

                        if (_currentChannel.AnchorPointSelected > 0)
                        {
                            _currentChannel.SetPoint(_currentChannel.AnchorPointSelected, coord, true);
                            // verify if P2 is > P3 or P2 < P1. P2 must be between P1 and P3
                            if ((_currentChannel.ChartP2.X > _currentChannel.ChartP3.X) ||
                                 (_currentChannel.ChartP2.X < _currentChannel.ChartP1.X))
                            {
                                int barpt2idx = channelLogic.CalcPt2BarIdx(_currentChannel);

                                bool upTrend = channelLogic.UpTrend(_currentChannel);
                                chartCoord chartCoord = chartHelper.GetChartCoordBarIndex(barpt2idx, upTrend);
                                if (!chartCoord.Valid) return;
                                _currentChannel.SetPoint(2, chartCoord, true);
                            }
                        }

                        channelLogic.DrawChannel(e.Graphics, _currentChannel, _drawingColor_channels, 1);
                    }
                }

            }
            catch (Exception) { }
        }

        // .....................    chart_MouseDown_channels
        private void chart_MouseDown_channels(object sender, MouseEventArgs e)
        {
            try
            {
                if (e.Button == MouseButtons.Left)
                {
                    chartHelper.chartControl = ChartControl;
                    if (_currentMode == ToolMode.Create)
                    {
                        if (_currentChannel.PointsCount == 0)
                        {
                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = channelLogic.Snap(null, coord, _snapColor);
                            _currentChannel.SetPoint(1, coord, false); // Set Point 1

                            _mouseCurrentPos = new Point(e.X, e.Y);
                            DrawMessage("New Channel\r\nClick Point 3:");
                        }
                        else if (_currentChannel.PointsCount == 1)
                        {
                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = channelLogic.Snap(null, coord, _snapColor);
                            _currentChannel.SetPoint(3, coord, false); // Set Point 3

                            int barpt2idx = channelLogic.CalcPt2BarIdx(_currentChannel);
                            bool upTrend = channelLogic.UpTrend(_currentChannel);
                            chartCoord chartCoord = chartHelper.GetChartCoordBarIndex(barpt2idx, upTrend);
                            if (!chartCoord.Valid) return;
                            _currentChannel.SetPoint(2, chartCoord, false);

                            _currentChannel.ReadyToDraw = true;
                            ChannelList.Add(_currentChannel);
                            _currentMode = ToolMode.Select;
                            _mouseCurrentPos = Point.Empty;
                            channelLogic.SerializeChannels(ChannelList, _fileName);
                            //Print (DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo () + "  CN=" + ChannelList.Count );
                            RemoveDrawObject(_msgID);
                        }
                    }
                    else if (_currentMode == ToolMode.Select || _currentMode == ToolMode.Selected)
                    {
                        if (_currentMode == ToolMode.Selected)
                        {
                            if (_currentChannel.AnchorPointSelected > 0 && _currentChannel.AnchorPointSelected < 4)
                            {
                                DrawMessage("Channel Selected\r\nMove Point and Click:");
                                channelLogic.SetCancelPoint(_currentChannel, _currentChannel.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                            else if (_currentChannel.AnchorPointSelected == 4)
                            {
                                DrawMessage("Channel Selected\r\nMove Extension Point and Click:");
                                channelLogic.SetCancelPoint(_currentChannel, _currentChannel.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                        }

                        bool noSelection = true;
                        Point testPnt = new Point(e.X, e.Y);

                        for (int i = 0; i < ChannelList.Count; i++)
                        {
                            if (channelLogic.IsInLine(ChannelList[i], testPnt))
                            {
                                noSelection = false;
                                // _LT_ replace message
                                //DrawMessage("Channel Selected:\r\n\r\nDelete  = Delete Channel\r\n- / +  = Change Width\r\n *  = Change Color");
                                DrawMessage("Channel Selected:\r\n\r\nDelete  = Delete Channel\r\n- / +  = Change Width\r\n *  = Change Color\r\n Alt + n = Toggle Numbers\r\n Alt + a = Toggle Alert");
                                _currentChannel = ChannelList[i];
                                _currentMode = ToolMode.Selected;
                            }
                        }

                        if ((noSelection) && (_currentMode == ToolMode.Selected))
                        {
                            RemoveDrawObject(_msgID);
                            _currentMode = ToolMode.Select;
                        }

                    }
                    else if (_currentMode == ToolMode.Edit)
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                        if (!coord.Valid) return;

                        coord = channelLogic.Snap(null, coord, _snapColor);

                        _currentChannel.SetPoint(_currentChannel.AnchorPointSelected, coord, false);
                        _currentChannel.ReadyToDraw = true;
                        channelLogic.DeSelect(_currentChannel);
                        _currentMode = ToolMode.Select;
                        channelLogic.SerializeChannels(ChannelList, _fileName);
                        //Print (DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo () + "  CN=" + ChannelList.Count );
                        RemoveDrawObject(_msgID);
                    }
                }

            }
            catch (Exception) { }
        }

        // .....................    chart_MouseMove_channels
        private void chart_MouseMove_channels(object sender, MouseEventArgs e)
        {
            if (_currentMode == ToolMode.Select)
                return;

            if (((_currentMode == ToolMode.Create) && (_currentChannel.PointsCount >= 0)) ||
                (_currentMode == ToolMode.Selected) || (_currentMode == ToolMode.Edit))
            {
                _mouseCurrentPos.X = e.X;
                _mouseCurrentPos.Y = e.Y;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
        }

        // .....................    chart_KeyDown_channels
        private void chart_KeyDown_channels(object sender, KeyEventArgs e)
        {
            //Print("Key Value=" + e.KeyValue + " Key Code= " + e.KeyCode + " Control=" + e.Control + " Alt=" + e.Alt);

            if (e.KeyCode == Keys.Insert)
            {
                _currentChannel = new Channel();
                _currentChannel.GtoolName = _defaultName_channels;      // _e_
                _currentChannel.ChannelColor = _defaultColor;
                _currentChannel.ChannelWidth = _defaultWidth;
                _currentMode = ToolMode.Create;
                _mouseCurrentPos = Point.Empty;
                DrawMessage("New Channel\r\nClick Point 1:");
            }
            if (e.KeyCode == Keys.Escape)
            {
                RemoveDrawObject(_msgID);

                if (_currentMode == ToolMode.Edit)
                {
                    channelLogic.CancelPoint(_currentChannel);
                    _currentChannel.ReadyToDraw = true;
                }
                _currentChannel = null;
                _currentMode = ToolMode.Select;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
            if (e.KeyCode == Keys.Delete)
            {
                if (e.Control == false)
                {
                    if (_currentMode == ToolMode.Selected)
                    {
                        int idx = ChannelList.IndexOf(_currentChannel);
                        ChannelList.RemoveAt(idx);
                        channelLogic.SerializeChannels(ChannelList, _fileName);
                        //Print(DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo() + "  CN=" + ChannelList.Count);
                        _currentMode = ToolMode.Select;
                        RemoveDrawObject(_msgID);
                    }
                }
                else
                {
                    DialogResult res = System.Windows.Forms.MessageBox.Show("Are you sure you want to DELETE all Channels ?", "WARNING !!!!", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                    if (res == DialogResult.No)
                        return;

                    ChannelList.Clear();
                    channelLogic.SerializeChannels(ChannelList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo() + "  CN=" + ChannelList.Count);

                    _currentMode = ToolMode.Select;
                    if (_currentMode == ToolMode.Selected)
                        RemoveDrawObject(_msgID);

                    if (ChartControl != null)
                        ChartControl.ChartPanel.Invalidate();
                }
            }
            if ((e.KeyCode == Keys.Add) || (e.KeyCode == Keys.Oemplus))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                        _currentChannel.ChannelWidth = Math.Min(4, _currentChannel.ChannelWidth + 1);

                    if (_currentChannel != null) //** _LT_ altered:
                    {
                        
                        SetAutoColor_channel(_currentChannel);

                        if (changeDefault)
                        {
                            _defaultWidth = _currentChannel.ChannelWidth;
                            changeDefault = false;
                        }
                    }
                    channelLogic.SerializeChannels(ChannelList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo() + "  CN=" + ChannelList.Count);
                }
            }
            // More Width Key
            if ((e.KeyCode == Keys.Subtract) || (e.KeyCode == Keys.Oem1))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                        _currentChannel.ChannelWidth = Math.Max(1, _currentChannel.ChannelWidth - 1);

                    if (_currentChannel != null) //** _LT_
                    {
                        SetAutoColor_channel(_currentChannel);

                        if (changeDefault)
                        {
                            _defaultWidth = _currentChannel.ChannelWidth;
                            changeDefault = false;
                        }
                    }

                    channelLogic.SerializeChannels(ChannelList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo() + "  CN=" + ChannelList.Count);
                }
            }
            // Change Channel Color Key
            if ((e.KeyCode == Keys.Multiply) || (e.KeyCode == Keys.Oem6))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                    {
                        Color backColor = Color.Empty;

                        if (ChartControl != null)
                            backColor = ChartControl.BackColor;

                        try
                        {
                            System.Windows.Forms.ColorDialog colorDialog = new System.Windows.Forms.ColorDialog();
                            colorDialog.AnyColor = true;
                            colorDialog.AllowFullOpen = true;
                            colorDialog.ShowDialog();

                            lock (_currentChannel)
                            {
                                if (colorDialog.Color != backColor)
                                    _currentChannel.ChannelColor = colorDialog.Color;

                                colorDialog.Dispose();

                                channelLogic.SerializeChannels(ChannelList, _fileName);
                                //Print(DateTime.Now.ToShortTimeString() + "=> " + channelLogic.GetDebugInfo() + "  CN=" + ChannelList.Count);

                                if (ChartControl != null)
                                    ChartControl.ChartPanel.Invalidate();
                            }
                        }
                        catch (StackOverflowException ex)
                        { }

                    }
                }
            }
            // _LT_begin add / subtract Numbers.
            //if (e.KeyCode == Keys.Divide)			// toggle point 123 labels on the selected channel
            if (e.Alt && e.KeyCode == Keys.N)
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                    {
                        _currentChannel.Numbers = !_currentChannel.Numbers;
                        channelLogic.SerializeChannels(ChannelList, _fileName);    // _e_tbc
                    }
                }
            }
            if (e.KeyCode == Keys.Oem5)
            {

                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                    {
                        changeDefault = !changeDefault;
                    }
                }
            }
            //if (e.KeyCode == Keys.A)		// toggle individual alarm enable on the selected gline
            if (e.Alt && e.KeyCode == Keys.A)
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentChannel != null)
                    {
                        _currentChannel.Alarm = !_currentChannel.Alarm;
                        channelLogic.SerializeChannels(ChannelList, _fileName);
                    }
                }
            } 
            // _LT_end
            e.Handled = true;
        }

        // _LT_begin
        public void SetAutoColor_channel(Channel _currentChannel)
        {
            if (_currentChannel != null)
            {
                if (autocolor)
                {
                    bool upTrend = channelLogic.UpTrend(_currentChannel);
                    if (upTrend)
                        switch (_currentChannel.ChannelWidth)
                        {
                            case 1: _currentChannel.ChannelColor = Color.Gray;
                                break;
                            case 2: _currentChannel.ChannelColor = Color.LightBlue;
                                break;
                            case 3: _currentChannel.ChannelColor = Color.Blue;
                                break;
                            case 4: _currentChannel.ChannelColor = Color.ForestGreen;
                                break;
                            case 5: _currentChannel.ChannelColor = Color.DarkBlue;
                                break;
                        }
                    else switch (_currentChannel.ChannelWidth)
                        {
                            case 1: _currentChannel.ChannelColor = Color.IndianRed;
                                break;
                            case 2: _currentChannel.ChannelColor = Color.MediumOrchid;
                                break;
                            case 3: _currentChannel.ChannelColor = Color.Red;
                                break;
                            case 4: _currentChannel.ChannelColor = Color.Purple;
                                break;
                            case 5: _currentChannel.ChannelColor = Color.DarkRed;
                                break;
                        }
                }
                //  else _currentChannel.ChannelColor = whatever it was
            }
        }

        // _LT_end
        #endregion

        #region CHANNEL ODB
        // .....................    Insert_grect
        public int Insert_channel(Channel channel)
        {
            int ret = Replace_channel(channel);
            return (ret);
        }
        // .....................    Replace_channel
        public int Replace_channel(Channel channel)
        {
            int _defaultWidthChannel = 20;
            int _defaultHeightChannel = -20;              // _e_ (0,0) (up,left)

            chartCoord ChartP1, ChartP2, ChartP3, ChartP4;
            Point P1, P2, P3, P4;

            if (channel.GtoolName == null) channel.GtoolName = _defaultName_channels;
            if (channel.ChannelColor == Color.Empty) channel.ChannelColor = _drawingColor_channels;
            if (channel.ChannelWidth == 0) channel.ChannelWidth = _defaultWidth;

            if (channel.PointsCount == 0) return 0;

            P1 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP1);

            int th = chartHelper.CalcTickHeight();

            if (channel.PointsCount == 1)
            {
                P3 = new Point(P1.X + _defaultWidthChannel, P1.Y + _defaultHeightChannel);

                ChartP3 = new chartCoord();
                ChartP3 = chartHelper.CalcChartCoordFromCanvasCoord(P3.X, P3.Y);

                TimeSpan t = chartHelper.ConvertIdxToTime(CurrentBar)
                        - chartHelper.ConvertIdxToTime(CurrentBar - 1);
                ChartP3.X = channel.ChartP1.X + t;
                ChartP3.Y = channel.ChartP1.Y + 4 * TickSize;   // _e_
                ChartP3.Valid = true;
                channel.SetPoint(3, ChartP3, false);
            }
            else
            {
                P3 = chartHelper.CalcCanvasCoordFromChartCoords(channel.ChartP3);
            }

            Delete_channel(channel);            // Delete channel if exists

            ChannelList = channelLogic.DeserializeChannels(_fileName, Bars.Get(0).Time);
            channel.ReadyToDraw = true;
            ChannelList.Add(channel);
            channelLogic.SerializeChannels(ChannelList, _fileName);

            return 1;
        }
        // .....................    Update_channel
        public int Update_channel(Channel channel)
        {
            int ret = Replace_channel(channel);
            return (ret);
        }
        // .....................    Delete_channel
        public int Delete_channel(Channel channel)
        {
            if (channel.GtoolName == null) channel.GtoolName = _defaultName_channels;
            ChannelList = channelLogic.DeserializeChannels(_fileName, Bars.Get(0).Time);
            for (int i = 0; i < ChannelList.Count; i++)
                if (ChannelList[i].GtoolName == channel.GtoolName) ChannelList.RemoveAt(i);
            channelLogic.SerializeChannels(ChannelList, _fileName);
            return 1;
        }
        // .....................    Update_channels_all
        public int Update_channels_all()
        {
            ChannelList = channelLogic.DeserializeChannels(_fileName, Bars.Get(0).Time);
            ChannelList.Clear();
            channelLogic.SerializeChannels(ChannelList, _fileName);
            return 1;
        }

        #endregion CHANNEL ODB


        // GRECTS

        #region GREC OVERRIDES

        // .....................    OnBarUpdate_onstart_grects
        protected void OnBarUpdate_onstart_grects()
        {
            if ((ChartControl != null) && (!_initMouseEvents))
            {
                if (_currentTool == Gtool.Grect)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_grects);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_grects);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_grects);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_grects);
                }

                _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                if (!Directory.Exists(_dirName))
                    Directory.CreateDirectory(_dirName);

                //_fileName_channels = _dirName + Instrument.FullName + "_" + Bars.Period.Value + ".dat";
                _fileName_grects = _dirName + Instrument.FullName + "_" + "grects" + "_" + Bars.Period.Value + ".dat";

                GrectList = grectLogic.DeserializeGrects(_fileName_grects, Bars.Get(0).Time);
                if (_currentTool == Gtool.Grect)
                {
                    _fileName = _fileName_grects;
                }

            }
        }

        // .....................    OnBarUpdate_onchange_grects
        protected void OnBarUpdate_onchange_grects()
        {
            if (_changedTool == true)
            {
                if (_previousTool == Gtool.Grect)
                {
                    this.ChartControl.ChartPanel.MouseDown -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_grects);
                    this.ChartControl.ChartPanel.MouseMove -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_grects);
                    this.ChartControl.ChartPanel.KeyDown -= new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_grects);
                    this.ChartControl.ChartPanel.Paint -= new System.Windows.Forms.PaintEventHandler(this.chart_Paint_grects);
                }

                if (_currentTool == Gtool.Grect)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_grects);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_grects);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_grects);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_grects);

                    _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                    if (!Directory.Exists(_dirName))
                        Directory.CreateDirectory(_dirName);

                    _fileName_grects = _dirName + Instrument.FullName + "_" + "grects" + "_" + Bars.Period.Value + ".dat";

                    GrectList = grectLogic.DeserializeGrects(_fileName_grects, Bars.Get(0).Time);

                        _fileName = _fileName_grects;

                }
            }
        }

        // .....................    Plot_grects
        public void Plot_grects(Graphics graphics, Rectangle bounds, double min, double max)
        {
            int cc = 0;

            if (GrectList != null)        // _e_
            {
                lock (GrectList)
                {
                    // Draw Grects

                    for (int i = 0; i < GrectList.Count; i++)
                        if (GrectList[i].ReadyToDraw)
                        {
                            cc++;
                            grectLogic.DrawGrect(graphics, GrectList[i], GrectList[i].GrectColor, GrectList[i].GrectWidth);
                        }
                }
            }
            //Print ("Plotting: Channel Count =" + cc);
        }

        #endregion

        #region Grect Logic
        public class GrectLogic
        {
            string _debug = "";
            private Bars Bars;
            private ChartHelper chartHelper;
            private bool _enableBinarySerialization;

            #region Initialization
            public GrectLogic(Bars ntBars, ChartHelper charthelper, bool enableBinarySerialization)
            {
                Bars = ntBars;
                chartHelper = charthelper;
            }

            public string GetDebugInfo()
            {
                return _debug;
            }
            #endregion

            #region Serialization
            public void SerializeGrects(List<Grect> grects, string file)
            {
                lock (grects)
                {
                    if (_enableBinarySerialization)
                        SaveGrectList(grects, file);
                    else
                        SaveGrectListXML(grects, file);
                }
            }
            public List<Grect> DeserializeGrects(string file, DateTime startTime)
            {
                if (_enableBinarySerialization)
                    return ReadGrectList(file, startTime);

                return ReadGrectListXML(file, startTime);
            }

            protected void SaveGrectListXML(List<Grect> grects, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";

                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Grect>));
                    serializer.Serialize(stream, grects);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {
                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }

            protected List<Grect> ReadGrectListXML(string file, DateTime startTime)
            {
                _debug = "";

                List<Grect> grects = new List<Grect>();
                Grect grect;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return grects;

                _debug = "Open File Ok\r\n";
                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Grect>));
                    _debug += "Try to deserialize\r\n";
                    grects = (List<Grect>)serializer.Deserialize(stream);
                    _debug += "Grect Count=" + grects.Count + "\r\n";
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(grects, startTime);

                return grects;
            }

            protected void SaveGrectList(List<Grect> grects, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();

                    formatter.Serialize(stream, grects);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {
                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }
            protected List<Grect> ReadGrectList(string file, DateTime startTime)
            {
                _debug = "";

                List<Grect> grects = new List<Grect>();
                Grect grect;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return grects;

                _debug = "Open File Ok\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();
                    _debug += "Try to deserialize\r\n";
                    grects = (List<Grect>)formatter.Deserialize(stream);
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(grects, startTime);

                return grects;
            }

            public void VerifyVisibility(List<Grect> grects, DateTime startTime)
            {
                for (int i = 0; i < grects.Count; i++)
                {
                    if (grects[i].ChartP1.X <= startTime)
                        grects[i].ReadyToDraw = false;
                    else
                        grects[i].ReadyToDraw = true;
                }
            }

            #endregion

            #region Snap

            public chartCoord Snap(Graphics graphics, chartCoord coord, Color color)
            {
                Point pntTest;
                Rectangle rectPoint;
                chartCoord retCoord = coord;

                int size = 8;

                Point pnt = chartHelper.CalcCanvasCoordFromChartCoords(coord);
                rectPoint = new Rectangle(pnt.X - (size / 2), pnt.Y - (size / 2), size, size);

                int barIdx = chartHelper.GetBarIdxFromChartCoord(coord);
                if ((barIdx < 0) && (barIdx >= Bars.Count))
                    return retCoord;

                for (int idx = barIdx - 1; idx < barIdx + 1; idx++)
                {
                    chartCoord coordHigh;
                    coordHigh.X = Bars.Get(idx).Time;
                    coordHigh.Y = Bars.Get(idx).High;
                    coordHigh.Valid = true;

                    chartCoord coordLow;
                    coordLow.X = Bars.Get(idx).Time;
                    coordLow.Y = Bars.Get(idx).Low;
                    coordLow.Valid = true;

                    pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordHigh);
                    rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);

                    if (rectPoint.Contains(pnt))
                    {
                        retCoord = coordHigh;
                        DrawSnap(graphics, rectPoint, color);
                        break;
                    }
                    else
                    {
                        pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordLow);
                        rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);
                        if (rectPoint.Contains(pnt))
                        {
                            retCoord = coordLow;
                            DrawSnap(graphics, rectPoint, color);
                            break;
                        }
                    }
                }

                return retCoord;
            }

            public void DrawSnap(Graphics graphics, Rectangle rect, Color color)
            {
                if (graphics == null)
                    return;

                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;

                graphics.FillRectangle(new SolidBrush(color), rect);

                graphics.SmoothingMode = oldSmoothingMode;
            }
            #endregion

            #region Trend Lines
            public bool UpTrend(Grect grect)
            {
                if (grect.ChartP3.Y > grect.ChartP1.Y)
                    return true;

                return false;
            }

            //_e_ begin 090313
            public Point CalcPt2(Grect grect)
            {
                // called from chart_MouseDown_grects ToolMode.Create 
                //      with PointsCount == 2
                chartCoord coord;
                Point P1, P3, P;

                P1 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP1);
                P3 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP3);

                P = P1;     //
                P.X = P1.X;
                P.Y = P3.Y;

                return P;
            }
            public Point CalcPt4(Grect grect)
            {
                // called from chart_MouseDown_grects ToolMode.Create 
                //      with PointsCount == 2
                chartCoord coord;
                Point P1, P3, P;

                P1 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP1);
                P3 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP3);

                P = P1; //
                P.X = P3.X;
                P.Y = P1.Y;

                return P;
            }
            //_e_ end 090313

            public int CalcPt2BarIdx(Grect grect)
            {
                int barIdx = 0;

                if ((grect.ChartP4.X <= grect.ChartP1.X))
                    return chartHelper.GetBarIdxFromChartCoord(grect.ChartP3);

                //Get bar index of most extreme bar between pt1 and pt3
                if (UpTrend(grect))
                    barIdx = GetBarIdxExtreme(grect.ChartP1, grect.ChartP3, true);
                else
                    barIdx = GetBarIdxExtreme(grect.ChartP1, grect.ChartP3, false);

                return barIdx;
            }

            public int GetBarIdxExtreme(chartCoord startCoord, chartCoord endCoord, bool highs)
            {
                chartCoord coord;
                chartCoord coordTest;
                Point pnt;
                LineEx paralell;

                int startBar = chartHelper.GetBarIdxFromChartCoord(startCoord);
                int endBar = chartHelper.GetBarIdxFromChartCoord(endCoord);

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(startCoord);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(endCoord);
                LineEx RTL = new LineEx(P1, P3);

                if (P1.X == 0)
                    return 0;

                int idx = startBar;
                do
                {
                    pnt = chartHelper.GetCanvasCoordBarIndex(idx, highs);
                    paralell = RTL.CreateParalell(pnt);

                    int i;
                    for (i = (idx + 1); i <= endBar; i++)
                    {
                        pnt = chartHelper.GetCanvasCoordBarIndex(i, highs);
                        if (paralell.IsPointOutOfLine(pnt, highs))
                            break;
                    }

                    if (i >= endBar)
                        break;

                    idx++;
                } while (idx <= (endBar));

                return idx;
            }

            public List<LineEx> CalcVEs(chartCoord startCoord, chartCoord point2, chartCoord point3, chartCoord endCoord, bool highs)
            {
                List<LineEx> ltls = new List<LineEx>();
                _debug = "";

                chartCoord coord;
                chartCoord coordTest;
                Point pnt1;
                Point pnt2;
                LineEx paralell;

                int startBar = chartHelper.GetBarIdxFromChartCoord(startCoord);
                int endBar = chartHelper.GetBarIdxFromChartCoord(endCoord);
                int Pt2Bar = chartHelper.GetBarIdxFromChartCoord(point2);

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(startCoord);
                Point P2 = chartHelper.CalcCanvasCoordFromChartCoords(point2);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(point3);
                Point P4 = chartHelper.CalcCanvasCoordFromChartCoords(endCoord);

                if (P2.X == 0)
                    return ltls;

                // _e_ begin
                LineEx RTL;
                RTL = new LineEx(P1, P2);
                ltls.Add(RTL);
                RTL = new LineEx(P2, P3);
                ltls.Add(RTL);
                RTL = new LineEx(P3, P4);
                ltls.Add(RTL);
                RTL = new LineEx(P4, P1);
                ltls.Add(RTL);

                return ltls;
            }

            public List<LineEx> CreateTrendlines(Grect grect)
            {
                string ss = "";

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP1);
                Point P2 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP2);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP3);
                Point P4 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP4);

                List<LineEx> TrendLines = new List<LineEx>();

                if (P1.X == 0)
                    return TrendLines;

                if (P1 == P3)
                    return TrendLines;

                    List<LineEx> ltls = CalcVEs(grect.ChartP1, grect.ChartP2, grect.ChartP3, grect.ChartP4, UpTrend(grect));
                    foreach (LineEx line in ltls)
                        TrendLines.Add(line);

                return TrendLines;
            }

            #endregion

            #region Drawing Grects

            public void DrawGrect(Graphics graphics, Grect grect)
            {
                List<LineEx> TrendLines = CreateTrendlines(grect);
                Draw(graphics, TrendLines, grect.GrectColor, grect.GrectWidth);
            }
            public void DrawGrect(Graphics graphics, Grect grect, Color color, int width)
            {
                List<LineEx> TrendLines = CreateTrendlines(grect);
                Draw(graphics, TrendLines, color, width);
            }
            protected void Draw(Graphics graphics, List<LineEx> TrendLines, Color color, int width)
            {
                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;
                Pen pen = new Pen(color, width);
                for (int i = 0; i < TrendLines.Count; i++)
                    graphics.DrawLine(pen, TrendLines[i].P1, TrendLines[i].P2);

                graphics.SmoothingMode = oldSmoothingMode;
            }
            #endregion

            #region Selection
            public bool IsInLine(Grect grect, Point pnt)
            {
                List<LineEx> TrendLines = CreateTrendlines(grect);

                Pen p = new Pen(Color.Black, 8);
                GraphicsPath pth = new GraphicsPath();

                for (int i = 0; i < TrendLines.Count; i++)
                {
                    pth.Reset();

                    if (TrendLines[i].P1 != TrendLines[i].P2)
                    {
                        pth.AddLine(TrendLines[i].P1, TrendLines[i].P2);
                        pth.Widen(p);

                        if (pth.IsVisible(pnt))
                        {
                            p.Dispose();
                            return true;
                        }
                    }
                }
                p.Dispose();
                return false;
            }

            public Rectangle[] CalcAnchorPoints(Grect grect)
            {
                Point pnt;
                Size sz = new Size(6, 6);
                Rectangle[] rectAnchor = new Rectangle[4];

                List<LineEx> TrendLines = CreateTrendlines(grect);

                //P1
                pnt = new Point(TrendLines[0].P1.X - 3, TrendLines[0].P1.Y - 3);
                rectAnchor[0] = new Rectangle(pnt, sz);

                //P2
                pnt = new Point(TrendLines[0].P1.X - 3, TrendLines[0].P1.Y - 3);
                rectAnchor[1] = new Rectangle(pnt, sz);

                //P3
                pnt = new Point(TrendLines[1].P2.X - 3, TrendLines[1].P2.Y - 3);
                rectAnchor[2] = new Rectangle(pnt, sz);
                // _e_ end

                return rectAnchor;
            }

            public int IsInAnchorPoint(Rectangle[] rectAnchor, Point pnt)
            {
                int AnchorPointSelected = 0;

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }
                return AnchorPointSelected;
            }

            public int IsInAnchorPoint(Grect grect, Point pnt)
            {
                int AnchorPointSelected = 0;

                if (!grect.IsSelected)
                    return AnchorPointSelected;

                Rectangle[] rectAnchor = CalcAnchorPoints(grect);

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }

                return AnchorPointSelected;
            }

            public void DrawAnchor(Graphics graphics, int point, Color color, bool inflate, Rectangle[] rectAnchor)
            {
                Rectangle rect;

                if (inflate)
                    rect = Rectangle.Inflate(rectAnchor[point - 1], 1, 1);
                else
                    rect = rectAnchor[point - 1];

                if (point < 4)
                    graphics.FillRectangle(new SolidBrush(color), rect);
                else
                    graphics.FillEllipse(new SolidBrush(color), rect);
            }

            public Rectangle[] Select(Graphics graphics, Grect grect, Color anchorColor, Color extensionColor)
            {
                Rectangle[] anchors = CalcAnchorPoints(grect);

                DrawAnchor(graphics, 1, anchorColor, false, anchors);
                DrawAnchor(graphics, 2, anchorColor, false, anchors);
                DrawAnchor(graphics, 3, anchorColor, false, anchors);

                DrawAnchor(graphics, 4, extensionColor, false, anchors);
                grect.IsSelected = true;
                return anchors;
            }

            public void DeSelect(Grect grect)
            {
                grect.IsSelected = false;
                grect.AnchorPointSelected = 0;
            }

            #endregion

            #region Cancel Points
            public void SetCancelPoint(Grect grect, int point)
            {
                if (point == 1) { grect.prevPointCoord = grect.ChartP1; }
                if (point == 2) { grect.prevPointCoord = grect.ChartP2; }
                if (point == 3) { grect.prevPointCoord = grect.ChartP3; }

                grect.CancelPoint = point;
            }
            public void CancelPoint(Grect grect)
            {
                if (grect.CancelPoint == 0)
                    return;

                if (grect.CancelPoint == 1) { grect.ChartP1 = grect.prevPointCoord; }
                if (grect.CancelPoint == 2) { grect.ChartP2 = grect.prevPointCoord; }
                if (grect.CancelPoint == 3) { grect.ChartP3 = grect.prevPointCoord; }
            }
            #endregion
        }
        #endregion

        #region Grect
        [Serializable()]
        public class Grect : ISerializable
        {
            // Private properties:
            private Color _grectColor;

            //Public properties:

            // Serialization properties
            public string GtoolName;      // _e_
            public bool Numbers;   //** palinuro's additions
            public bool Alarm;  //** palinuro's additions
            public int PointsCount;
            public bool ReadyToDraw;
            public chartCoord ChartP1;
            public chartCoord ChartP2;
            public chartCoord ChartP3;
            public chartCoord ChartP4;
            public int GrectWidth;
            public int GrectColorSerialize
            {
                get { return _grectColor.ToArgb(); }
                set { _grectColor = Color.FromArgb(value); }
            }
            // End

            [XmlIgnore()]
            public Color GrectColor
            {
                get { return _grectColor; }
                set { _grectColor = value; }
            }

            [XmlIgnore()]
            [NonSerialized()]
            public bool IsSelected = false;
            [XmlIgnore()]
            [NonSerialized()]
            public int AnchorPointSelected = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public int CancelPoint = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public chartCoord prevPointCoord;

            public Grect()
            {
                PointsCount = 0;
                ReadyToDraw = false;
                Numbers = false; // _Palinuro_
                Alarm = false; // _Palinuro_
            }

            public void ResetPoints()
            {
                PointsCount = 0;
            }

            public void SetPoint(int id, chartCoord coord, bool noCount)
            {
                if (id == 1) ChartP1 = coord;
                if (id == 2) ChartP2 = coord;
                if (id == 3) { ChartP3 = coord; }
                if (id == 4) ChartP4 = coord;

                if (!noCount)
                    PointsCount++;
            }
            public void SetPoint(int id, DateTime barX, double price, bool noCount)
            {
                if (id == 1) { ChartP1.X = barX; ChartP1.Y = price; }
                if (id == 2) { ChartP2.X = barX; ChartP2.Y = price; }
                if (id == 3) { ChartP3.X = barX; ChartP3.Y = price; }
                if (id == 4) { ChartP4.X = barX; ChartP4.Y = price; }

                if (!noCount)
                    PointsCount++;
            }

            #region "Binary Serialization"
            // Used only for Binary Serialization
            public Grect(SerializationInfo info, StreamingContext ctxt)
            {
                //Get the values from info and assign them to the appropriate properties
                GtoolName = (string)info.GetValue("GtoolName", typeof(string));
                Numbers = (bool)info.GetValue("Numbers", typeof(bool));	//**
                Alarm = (bool)info.GetValue("Alarm", typeof(bool));	//**
                PointsCount = (int)info.GetValue("PointsCount", typeof(int));
                ReadyToDraw = (bool)info.GetValue("ReadyToDraw", typeof(bool));
                ChartP1.X = (DateTime)info.GetValue("ChartP1.X", typeof(DateTime));
                ChartP1.Y = (double)info.GetValue("ChartP1.Y", typeof(double));
                ChartP1.Valid = (bool)info.GetValue("ChartP1.Valid", typeof(bool));
                ChartP2.X = (DateTime)info.GetValue("ChartP2.X", typeof(DateTime));
                ChartP2.Y = (double)info.GetValue("ChartP2.Y", typeof(double));
                ChartP2.Valid = (bool)info.GetValue("ChartP2.Valid", typeof(bool));
                ChartP3.X = (DateTime)info.GetValue("ChartP3.X", typeof(DateTime));
                ChartP3.Y = (double)info.GetValue("ChartP3.Y", typeof(double));
                ChartP3.Valid = (bool)info.GetValue("ChartP3.Valid", typeof(bool));
                ChartP4.X = (DateTime)info.GetValue("ChartP4.X", typeof(DateTime));
                ChartP4.Y = (double)info.GetValue("ChartP4.Y", typeof(double));
                ChartP4.Valid = (bool)info.GetValue("ChartP4.Valid", typeof(bool));
                GrectWidth = (int)info.GetValue("GrectWidth", typeof(int));
                GrectColor = (Color)info.GetValue("GrectColor", typeof(Color));
            }

            //Serialization function.
            public void GetObjectData(SerializationInfo info, StreamingContext ctxt)
            {
                //You can use any custom name for your name-value pair. But make sure you
                // read the values with the same name. For ex:- If you write EmpId as "EmployeeId"
                // then you should read the same with "EmployeeId"
                info.AddValue("GtoolName", GtoolName);
                info.AddValue("Numbers", Numbers);  //** tg
                info.AddValue("Alarm", Alarm);    //** tg
                info.AddValue("PointsCount", PointsCount);
                info.AddValue("ReadyToDraw", ReadyToDraw);
                info.AddValue("ChartP1.X", ChartP1.X);
                info.AddValue("ChartP1.Y", ChartP1.Y);
                info.AddValue("ChartP1.Valid", ChartP1.Valid);
                info.AddValue("ChartP2.X", ChartP2.X);
                info.AddValue("ChartP2.Y", ChartP2.Y);
                info.AddValue("ChartP2.Valid", ChartP2.Valid);
                info.AddValue("ChartP3.X", ChartP3.X);
                info.AddValue("ChartP3.Y", ChartP3.Y);
                info.AddValue("ChartP3.Valid", ChartP3.Valid);
                info.AddValue("ChartP4.X", ChartP4.X);
                info.AddValue("ChartP4.Y", ChartP4.Y);
                info.AddValue("ChartP4.Valid", ChartP4.Valid);
                info.AddValue("GrectWidth", GrectWidth);
                info.AddValue("GrectColor", GrectColor);
            }
            #endregion



        }
        #endregion

        #region Methods GRECT
        // .....................    chart_Paint_grects
        public void chart_Paint_grects(object sender, PaintEventArgs e)
        {
            chartHelper.chartControl = ChartControl;

            if (_currentMode == ToolMode.Select)
                return;

            try
            {
                if (_currentMode == ToolMode.Create)
                {
                    if ((_mouseCurrentPos != Point.Empty) || (_currentGrect != null))
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = grectLogic.Snap(e.Graphics, coord, _snapColor);

                        if (!_currentGrect.ChartP1.Valid)
                            return;

                        _currentGrect.SetPoint(3, coord, true);

                        chartCoord coord2 = new chartCoord();
                        coord2.X = _currentGrect.ChartP1.X;
                        coord2.Y = _currentGrect.ChartP3.Y;
                        _currentGrect.SetPoint(2, coord2, true);

                        chartCoord coord4 = new chartCoord();
                        coord4.X = _currentGrect.ChartP3.X;
                        coord4.Y = _currentGrect.ChartP1.Y;
                        _currentGrect.SetPoint(4, coord4, true);


                        grectLogic.DrawGrect(e.Graphics, _currentGrect, _drawingColor_grects, 1);
                    }
                }
                else if ((_currentMode == ToolMode.Selected))
                {

                    Rectangle[] anchors = grectLogic.Select(e.Graphics, _currentGrect, _anchorColor, _extensionColor_grects);

                    _currentGrect.AnchorPointSelected = grectLogic.IsInAnchorPoint(anchors, new Point(_mouseCurrentPos.X, _mouseCurrentPos.Y));
                    if (_currentGrect.AnchorPointSelected > 0 && _currentGrect.AnchorPointSelected < 4)
                        grectLogic.DrawAnchor(e.Graphics, _currentGrect.AnchorPointSelected, _anchorColor, true, anchors);
                    else if (_currentGrect.AnchorPointSelected == 4)
                        grectLogic.DrawAnchor(e.Graphics, _currentGrect.AnchorPointSelected, _extensionColor_grects, true, anchors);
                }
                else if (_currentMode == ToolMode.Edit)
                {
                    if ((_mouseCurrentPos != Point.Empty) || (_currentGrect != null))
                    {
                        _currentGrect.ReadyToDraw = false;

                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = grectLogic.Snap(e.Graphics, coord, _snapColor);

                        if (_currentGrect.AnchorPointSelected > 0)
                        {
                            _currentGrect.SetPoint(_currentGrect.AnchorPointSelected, coord, true);
                            chartCoord coord2 = new chartCoord();
                            coord2.X = _currentGrect.ChartP1.X;
                            coord2.Y = _currentGrect.ChartP3.Y;
                            _currentGrect.SetPoint(2, coord2, true);

                            chartCoord coord4 = new chartCoord();
                            coord4.X = _currentGrect.ChartP3.X;
                            coord4.Y = _currentGrect.ChartP1.Y;
                            _currentGrect.SetPoint(4, coord4, true);

                            // _e_ end
                        }

                        grectLogic.DrawGrect(e.Graphics, _currentGrect, _drawingColor_grects, 1);
                    }
                }

            }
            catch (Exception) { }
        }

        // .....................    chart_MouseDown_grects
        private void chart_MouseDown_grects(object sender, MouseEventArgs e)
        {
            try
            {
                if (e.Button == MouseButtons.Left)
                {
                    chartHelper.chartControl = ChartControl;
                    if (_currentMode == ToolMode.Create)
                    {
                        if (_currentGrect.PointsCount == 0)
                        {
                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = grectLogic.Snap(null, coord, _snapColor);
                            _currentGrect.SetPoint(1, coord, false); // Set Point 1

                            _mouseCurrentPos = new Point(e.X, e.Y);
                            DrawMessage("New Grect\r\nClick Point 3:");
                        }
                        else if (_currentGrect.PointsCount == 1)
                        {
                            //Print(DateTime.Now.ToShortTimeString() + "=> " + "  _currentGrect.PointsCount == 1");

                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = grectLogic.Snap(null, coord, _snapColor);
                            _currentGrect.SetPoint(3, coord, false); // Set Point 3

                            chartCoord coord2 = new chartCoord();
                            coord2.X = _currentGrect.ChartP1.X;
                            coord2.Y = _currentGrect.ChartP3.Y;
                            _currentGrect.SetPoint(2, coord2, false);

                            chartCoord coord4 = new chartCoord();
                            coord4.X = _currentGrect.ChartP3.X;
                            coord4.Y = _currentGrect.ChartP1.Y;
                            _currentGrect.SetPoint(4, coord4, false);

                            _currentGrect.ReadyToDraw = true;
                            GrectList.Add(_currentGrect);
                            _currentMode = ToolMode.Select;
                            _mouseCurrentPos = Point.Empty;
                            grectLogic.SerializeGrects(GrectList, _fileName);
                            //Print(DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo() + "  CN=" + GrectList.Count);
                            RemoveDrawObject(_msgID);
                        }
                    }
                    else if (_currentMode == ToolMode.Select || _currentMode == ToolMode.Selected)
                    {
                        if (_currentMode == ToolMode.Selected)
                        {
                            if (_currentGrect.AnchorPointSelected > 0 && _currentGrect.AnchorPointSelected < 4)
                            {
                                DrawMessage("Grect Selected\r\nMove Point and Click:");
                                grectLogic.SetCancelPoint(_currentGrect, _currentGrect.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                            else if (_currentGrect.AnchorPointSelected == 4)
                            {
                                DrawMessage("Grect Selected\r\nMove Extension Point and Click:");
                                grectLogic.SetCancelPoint(_currentGrect, _currentGrect.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                        }

                        bool noSelection = true;
                        Point testPnt = new Point(e.X, e.Y);

                        for (int i = 0; i < GrectList.Count; i++)
                        {
                            if (grectLogic.IsInLine(GrectList[i], testPnt))
                            {
                                noSelection = false;
                                DrawMessage("Grect Selected:\r\n\r\nDelete  = Delete Grect\r\n- / +  = Change Width\r\n *  = Change Color");
                                _currentGrect = GrectList[i];
                                _currentMode = ToolMode.Selected;
                            }
                        }

                        if ((noSelection) && (_currentMode == ToolMode.Selected))
                        {
                            RemoveDrawObject(_msgID);
                            _currentMode = ToolMode.Select;
                        }

                    }
                    else if (_currentMode == ToolMode.Edit)
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                        if (!coord.Valid) return;

                        coord = grectLogic.Snap(null, coord, _snapColor);

                        _currentGrect.SetPoint(_currentGrect.AnchorPointSelected, coord, true);
                        _currentGrect.ReadyToDraw = true;
                        grectLogic.DeSelect(_currentGrect);
                        _currentMode = ToolMode.Select;
                        grectLogic.SerializeGrects(GrectList, _fileName);
                        //Print (DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo () + "  CN=" + GrectList.Count );
                        RemoveDrawObject(_msgID);
                    }
                }

            }
            catch (Exception) { }
        }

        // .....................    chart_MouseMove_grects
        private void chart_MouseMove_grects(object sender, MouseEventArgs e)
        {
            if (_currentMode == ToolMode.Select)
                return;

            if (((_currentMode == ToolMode.Create) && (_currentGrect.PointsCount >= 0)) ||
                (_currentMode == ToolMode.Selected) || (_currentMode == ToolMode.Edit))
            {
                _mouseCurrentPos.X = e.X;
                _mouseCurrentPos.Y = e.Y;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
        }

        // .....................    chart_KeyDown_grects
        private void chart_KeyDown_grects(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Insert)
            {
                _currentGrect = new Grect();
                _currentGrect.GtoolName = _defaultName_grects;
                _currentGrect.GrectColor = _defaultColor;
                _currentGrect.GrectWidth = _defaultWidth;
                _currentMode = ToolMode.Create;
                _mouseCurrentPos = Point.Empty;
                DrawMessage("New Grect\r\nClick Point 1:");
            }
            if (e.KeyCode == Keys.Escape)
            {
                RemoveDrawObject(_msgID);

                if (_currentMode == ToolMode.Edit)
                {
                    grectLogic.CancelPoint(_currentGrect);
                    _currentGrect.ReadyToDraw = true;
                }
                _currentGrect = null;
                _currentMode = ToolMode.Select;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
            if (e.KeyCode == Keys.Delete)
            {
                if (e.Control == false)
                {
                    if (_currentMode == ToolMode.Selected)
                    {
                        int idx = GrectList.IndexOf(_currentGrect);
                        GrectList.RemoveAt(idx);
                        grectLogic.SerializeGrects(GrectList, _fileName);
                        //Print(DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo() + "  CN=" + GrectList.Count);
                        _currentMode = ToolMode.Select;
                        RemoveDrawObject(_msgID);
                    }
                }
                else
                {
                    DialogResult res = System.Windows.Forms.MessageBox.Show("Are you sure you want to DELETE all Grects ?", "WARNING !!!!", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                    if (res == DialogResult.No)
                        return;

                    GrectList.Clear();
                    grectLogic.SerializeGrects(GrectList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo() + "  CN=" + GrectList.Count);

                    _currentMode = ToolMode.Select;
                    if (_currentMode == ToolMode.Selected)
                        RemoveDrawObject(_msgID);

                    if (ChartControl != null)
                        ChartControl.ChartPanel.Invalidate();
                }
            }
            if ((e.KeyCode == Keys.Add) || (e.KeyCode == Keys.Oemplus))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGrect != null)
                        _currentGrect.GrectWidth = Math.Min(4, _currentGrect.GrectWidth + 1);

                    grectLogic.SerializeGrects(GrectList, _fileName);
                    //Print (DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo () + "  CN=" + GrectList.Count );
                }
            }
            // More Width Key
            if ((e.KeyCode == Keys.Subtract) || (e.KeyCode == Keys.Oem1))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGrect != null)
                        _currentGrect.GrectWidth = Math.Max(1, _currentGrect.GrectWidth - 1);

                    grectLogic.SerializeGrects(GrectList, _fileName);
                    //Print (DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo () + "  CN=" + GrectList.Count );
                }
            }
            // Change Grect Color Key
            if ((e.KeyCode == Keys.Multiply) || (e.KeyCode == Keys.Oem6))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGrect != null)
                    {
                        Color backColor = Color.Empty;

                        if (ChartControl != null)
                            backColor = ChartControl.BackColor;

                        try
                        {
                            System.Windows.Forms.ColorDialog colorDialog = new System.Windows.Forms.ColorDialog();
                            colorDialog.AnyColor = true;
                            colorDialog.AllowFullOpen = true;
                            colorDialog.ShowDialog();

                            lock (_currentGrect)
                            {
                                if (colorDialog.Color != backColor)
                                    _currentGrect.GrectColor = colorDialog.Color;

                                colorDialog.Dispose();

                                grectLogic.SerializeGrects(GrectList, _fileName);
                                //Print (DateTime.Now.ToShortTimeString() + "=> " + grectLogic.GetDebugInfo () + "  CN=" + GrectList.Count );

                                if (ChartControl != null)
                                    ChartControl.ChartPanel.Invalidate();
                            }
                        }
                        catch (StackOverflowException ex)
                        { }

                    }
                }
            }

            e.Handled = true;
        }


        #endregion

        #region GRECT ODB
        // .....................    Insert_grect
        public int Insert_grect(Grect grect)
        {
            int ret = Replace_grect(grect);
            return (ret);
        }
        // .....................    Replace_grect
        public int Replace_grect(Grect grect)
        {
            int _defaultWidthGrect = 20;
            int _defaultHeightGrect = -20;              // _e_ (0,0) (up,left)

            chartCoord ChartP1, ChartP2, ChartP3, ChartP4;
            Point P1, P2, P3, P4;

            if (grect.GtoolName == null) grect.GtoolName = _defaultName_grects;
            if (grect.GrectColor == Color.Empty) grect.GrectColor = _drawingColor_grects;
            if (grect.GrectWidth == 0) grect.GrectWidth = _defaultWidth;

            if (grect.PointsCount == 0) return 0;

            P1 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP1);

            int th = chartHelper.CalcTickHeight();

            if (grect.PointsCount == 1)
            {
                P3 = new Point(P1.X + _defaultWidthGrect, P1.Y + _defaultHeightGrect);

                ChartP3 = new chartCoord();
                ChartP3 = chartHelper.CalcChartCoordFromCanvasCoord(P3.X, P3.Y);

                TimeSpan t = chartHelper.ConvertIdxToTime(CurrentBar)
                        - chartHelper.ConvertIdxToTime(CurrentBar - 1);
                ChartP3.X = grect.ChartP1.X + t;
                ChartP3.Y = grect.ChartP1.Y + 4 * TickSize;   // _e_
                ChartP3.Valid = true;
                grect.SetPoint(3, ChartP3, false);
            }
            else
            {
                P3 = chartHelper.CalcCanvasCoordFromChartCoords(grect.ChartP3);
            }

            ChartP2.X = grect.ChartP1.X;
            ChartP2.Y = grect.ChartP3.Y;
            ChartP2.Valid = true;
            grect.SetPoint(2, ChartP2, false);

            ChartP4.X = grect.ChartP3.X;
            ChartP4.Y = grect.ChartP1.Y;
            ChartP4.Valid = true;
            grect.SetPoint(4, ChartP4, false);

            Delete_grect(grect);            // Delete grec if exists

            GrectList = grectLogic.DeserializeGrects(_fileName, Bars.Get(0).Time);
            grect.ReadyToDraw = true;
            GrectList.Add(grect);
            grectLogic.SerializeGrects(GrectList, _fileName);

            return 1;


        }
        // .....................    Update_grect
        public int Update_grect(Grect grect)
        {
            int ret = Replace_grect(grect);
            return (ret);
        }
        // .....................    Delete_grect
        public int Delete_grect(Grect grect)
        {
            if (grect.GtoolName == null) grect.GtoolName = _defaultName_grects;
            GrectList = grectLogic.DeserializeGrects(_fileName, Bars.Get(0).Time);
            for (int i = 0; i < GrectList.Count; i++)
                if (GrectList[i].GtoolName == grect.GtoolName) GrectList.RemoveAt(i);
            grectLogic.SerializeGrects(GrectList, _fileName);
            return 1;
        }
        // .....................    Update_grects_all
        public int Update_grects_all()
        {
            GrectList = grectLogic.DeserializeGrects(_fileName, Bars.Get(0).Time);
            GrectList.Clear();
            grectLogic.SerializeGrects(GrectList, _fileName);
            return 1;
        }

        #endregion GRECT ODB

        // GLINES

        #region GLINE OVERRIDES

        // .....................    OnBarUpdate_onstart_glines
        protected void OnBarUpdate_onstart_glines()
        {
            if ((ChartControl != null) && (!_initMouseEvents))
            {
                if (_currentTool == Gtool.Gline)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_glines);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_glines);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_glines);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_glines);
                }

                _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                if (!Directory.Exists(_dirName))
                    Directory.CreateDirectory(_dirName);

                _fileName_glines = _dirName + Instrument.FullName + "_" + "glines" + "_" + Bars.Period.Value + ".dat";

                GlineList = glineLogic.DeserializeGlines(_fileName_glines, Bars.Get(0).Time);
            }
            if (_currentTool == Gtool.Gline)
            {
                _fileName = _fileName_glines;
            }

        }

        // .....................    OnBarUpdate_onchange_glines
        protected void OnBarUpdate_onchange_glines()
        {
            if (_changedTool == true)
            {
                if (_previousTool == Gtool.Gline)
                {
                    this.ChartControl.ChartPanel.MouseDown -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_glines);
                    this.ChartControl.ChartPanel.MouseMove -= new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_glines);
                    this.ChartControl.ChartPanel.KeyDown -= new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_glines);
                    this.ChartControl.ChartPanel.Paint -= new System.Windows.Forms.PaintEventHandler(this.chart_Paint_glines);
                }

                if (_currentTool == Gtool.Gline)
                {
                    this.ChartControl.ChartPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.chart_MouseDown_glines);
                    this.ChartControl.ChartPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove_glines);
                    this.ChartControl.ChartPanel.KeyDown += new System.Windows.Forms.KeyEventHandler(this.chart_KeyDown_glines);
                    this.ChartControl.ChartPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.chart_Paint_glines);

                    _dirName = Environment.GetFolderPath(Environment.SpecialFolder.CommonProgramFiles) + "\\NinjaTrader\\";

                    if (!Directory.Exists(_dirName))
                        Directory.CreateDirectory(_dirName);

                    _fileName_glines = _dirName + Instrument.FullName + "_" + "glines" + "_" + Bars.Period.Value + ".dat";

                    GlineList = glineLogic.DeserializeGlines(_fileName_glines, Bars.Get(0).Time);

                        _fileName = _fileName_glines;

                }
            }
        }

        // .....................    Plot_glines
        public void Plot_glines(Graphics graphics, Rectangle bounds, double min, double max)
        {
            int cc = 0;

            //if (GlineList != null)        // _e_
            //{
                lock (GlineList)
                {
                    // Draw Glines

                    for (int i = 0; i < GlineList.Count; i++)
                        if (GlineList[i].ReadyToDraw)
                        {
                            cc++;
                            glineLogic.DrawGline(graphics, GlineList[i], GlineList[i].GlineColor, GlineList[i].GlineWidth);

                            // _LT_
                            if (GlineList[i].Numbers)
                            {
                                Color test = GlineList[i].GlineColor;
                                SolidBrush brushN = new SolidBrush(test);
                                int thisFont = fontSize + 3 * GlineList[i].GlineWidth;
                                Font f = new Font("Arial", 11, FontStyle.Bold, GraphicsUnit.Pixel);
                                size = graphics.MeasureString("1", f);

                                int space1;
                                int space2;
                                    space1 = Convert.ToInt16(Math.Round(0.4 * size.Height));
                                    space2 = -Convert.ToInt16(Math.Round(1.4 * size.Height));

                                float y = chartHelper.ConvertPriceToY(GlineList[i].ChartP1.Y) + space1;
                                int baridx = Bars.GetBar((GlineList[i].ChartP1.X));
                                int x = ChartControl.GetXByBarIdx(baridx) - Convert.ToInt16(0.4 * size.Width);
                                PointF NumPoint1 = new PointF(x, y);
                                //graphics.DrawString("1", f, brushN, NumPoint1);
                                string t1 = GlineList[i].ChartP1.X.ToString("HH:mm");
                                string p1 = GlineList[i].ChartP1.Y.ToString();
                                string m1 = "("+t1+", "+p1+")";
                                graphics.DrawString(m1, f, brushN, NumPoint1);

                                y = chartHelper.ConvertPriceToY(GlineList[i].ChartP3.Y) + space1;
                                baridx = Bars.GetBar((GlineList[i].ChartP3.X));
                                x = ChartControl.GetXByBarIdx(baridx) - Convert.ToInt16(0.4 * size.Width);
                                PointF NumPoint3 = new PointF(x, y);
                                //graphics.DrawString("3", f, brushN, NumPoint3);
                                string t2 = GlineList[i].ChartP3.X.ToString("HH:mm");
                                string p2 = GlineList[i].ChartP3.Y.ToString();
                                string m2 = "("+t2+", "+p2+")";
                                graphics.DrawString(m2, f, brushN, NumPoint3);

                                //Print("-- Numbers on: " + cc);
                            }

                            if (GlineList[i].Alarm)
                            {
                                int x = ChartControl.GetXByBarIdx(CurrentBar);   //canvas point int x 
                                double y1 = (GlineList[i].ChartP1.Y);
                                int baridx1 = Bars.GetBar((GlineList[i].ChartP1.X));		// only works if P1 <= CurrentBar
                                double y3 = (GlineList[i].ChartP3.Y);
                                int baridx3 = chartHelper.ConvertTimeToIdx((GlineList[i].ChartP3.X));
                                double slope = (double)(y3 - y1) / (double)(baridx3 - baridx1);

                                //double slope = channelLogic.Slope( ChannelList[i] );
                                double currenty = slope * (CurrentBar - baridx1) + y1;	// the trigger value										
                                Color textcolor = GlineList[i].GlineColor;				// set up the text font
                                Font f = new Font("Arial", 11, FontStyle.Bold, GraphicsUnit.Pixel);
                                size = graphics.MeasureString("1", f);
                                Color backColor = Color.Empty;
                                if (ChartControl != null) backColor = ChartControl.BackColor;

                                string alarm_msg = "[" + Bars.Period.Value.ToString() + " " + Bars.Period.Id.ToString() + "] RTL Breach @ " + Close[0].ToString();
                                string alarm_tag = "RTLAlert" + i.ToString() + "_" + CurrentBar.ToString();

                                SolidBrush brushN = new SolidBrush(textcolor); // for on-chart use
                                //if (y3 > y1 ) 					
                                if (glineLogic.UpTrend(GlineList[i]))
                                {
                                    float y = chartHelper.ConvertPriceToY(currenty) + (size.Height);
                                    PointF NumPoint3 = new PointF(x, y);
                                    graphics.DrawString("RTL Alert @ " + Math.Round(currenty, 2).ToString(), f, brushN, NumPoint3);

                                    if ((Close[0] < currenty) && (prevTick >= prevTrigger)
                                        || (Close[0] >= currenty) && (prevTick < prevTrigger))   // cross RTL
                                    //if ((Close[0] < currenty))
                                    {
                                        Alert(alarm_tag, NinjaTrader.Cbi.Priority.High, alarm_msg, alarm_sound, 10, backColor, textcolor);
                                        GlineList[i].Alarm = false;    // we triggered so now disable (don't want to be annoying)
                                        glineLogic.SerializeGlines(GlineList, _fileName);
                                    }
                                }
                                else //if (y3 < y1) 
                                {
                                    float y = chartHelper.ConvertPriceToY(currenty) - 2 * (size.Height);
                                    PointF NumPoint3 = new PointF(x, y);
                                    graphics.DrawString("RTL Alert @ " + Math.Round(currenty, 2).ToString(), f, brushN, NumPoint3);

                                    if ((Close[0] > currenty) && (prevTick <= currenty)
                                        || (Close[0] <= currenty) && (prevTick > currenty))   // cross RTL
                                    //if ((Close[0] > currenty))
                                    {
                                        Alert(alarm_tag, NinjaTrader.Cbi.Priority.High, alarm_msg, alarm_sound, 10, backColor, textcolor);
                                        GlineList[i].Alarm = false;    // we triggered so now disable (don't want to be annoying)
                                        glineLogic.SerializeGlines(GlineList, _fileName);
                                    }
                                }
                                /*Print("-- Alarm on: " + cc + " slope=" + Math.Round(slope,2).ToString() 
                                        + " P3=" + baridx3.ToString() + " " + GlineList[i].ChartP3.X.ToString() 
                                        + " C=" + prevTick.ToString() + " Tr=" + prevTrigger.ToString() );  */
                                prevTrigger = currenty;
                                prevTick = Close[0];
                            }   //  Alarm IF routine
                            // _LT_


                        }
                }
            //}
            //Print ("Plotting: Channel Count =" + cc);
        }

        #endregion

        #region Gline Logic
        public class GlineLogic
        {
            string _debug = "";
            private Bars Bars;
            private ChartHelper chartHelper;
            private bool _enableBinarySerialization;

            #region Initialization
            public GlineLogic(Bars ntBars, ChartHelper charthelper, bool enableBinarySerialization)
            {
                Bars = ntBars;
                chartHelper = charthelper;
            }

            public string GetDebugInfo()
            {
                return _debug;
            }
            #endregion

            #region Serialization
            public void SerializeGlines(List<Gline> glines, string file)
            {
                lock (glines)
                {
                    if (_enableBinarySerialization)
                        SaveGlineList(glines, file);
                    else
                        SaveGlineListXML(glines, file);
                }
            }
            public List<Gline> DeserializeGlines(string file, DateTime startTime)
            {
                if (_enableBinarySerialization)
                    return ReadGlineList(file, startTime);

                return ReadGlineListXML(file, startTime);
            }

            protected void SaveGlineListXML(List<Gline> glines, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";

                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Gline>));
                    serializer.Serialize(stream, glines);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {
                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }

            protected List<Gline> ReadGlineListXML(string file, DateTime startTime)
            {
                _debug = "";

                List<Gline> glines = new List<Gline>();
                Gline gline;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return glines;

                _debug = "Open File Ok\r\n";
                try
                {
                    XmlSerializer serializer = new XmlSerializer(typeof(List<Gline>));
                    _debug += "Try to deserialize\r\n";
                    glines = (List<Gline>)serializer.Deserialize(stream);
                    _debug += "Gline Count=" + glines.Count + "\r\n";
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(glines, startTime);

                return glines;
            }

            protected void SaveGlineList(List<Gline> glines, string file)
            {
                _debug = "";

                FileStream stream = new FileStream(file, FileMode.Create);
                _debug += "File created OK\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();

                    formatter.Serialize(stream, glines);
                    _debug += "Serialization OK\r\n";
                }
                catch (Exception e)
                {
                    _debug += "error: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }
            }
            protected List<Gline> ReadGlineList(string file, DateTime startTime)
            {
                _debug = "";

                List<Gline> glines = new List<Gline>();
                Gline gline;
                FileStream stream;

                if (File.Exists(file))
                    stream = new FileStream(file, FileMode.Open);
                else
                    return glines;

                _debug = "Open File Ok\r\n";
                try
                {
                    BinaryFormatter formatter = new BinaryFormatter();
                    _debug += "Try to deserialize\r\n";
                    glines = (List<Gline>)formatter.Deserialize(stream);
                }
                catch (Exception e)
                {
                    _debug += "Exception: " + e.Message + "\r\n";
                }
                finally
                {
                    stream.Close();
                    _debug += "Close OK\r\n";
                }

                VerifyVisibility(glines, startTime);

                return glines;
            }

            public void VerifyVisibility(List<Gline> glines, DateTime startTime)
            {
                for (int i = 0; i < glines.Count; i++)
                {
                    if (glines[i].ChartP1.X <= startTime)
                        glines[i].ReadyToDraw = false;
                    else
                        glines[i].ReadyToDraw = true;
                }
            }

            #endregion

            #region Snap

            public chartCoord Snap(Graphics graphics, chartCoord coord, Color color)
            {
                Point pntTest;
                Rectangle rectPoint;
                chartCoord retCoord = coord;

                int size = 8;

                Point pnt = chartHelper.CalcCanvasCoordFromChartCoords(coord);
                rectPoint = new Rectangle(pnt.X - (size / 2), pnt.Y - (size / 2), size, size);

                int barIdx = chartHelper.GetBarIdxFromChartCoord(coord);
                if ((barIdx < 0) && (barIdx >= Bars.Count))
                    return retCoord;

                for (int idx = barIdx - 1; idx < barIdx + 1; idx++)
                {
                    chartCoord coordHigh;
                    coordHigh.X = Bars.Get(idx).Time;
                    coordHigh.Y = Bars.Get(idx).High;
                    coordHigh.Valid = true;

                    chartCoord coordLow;
                    coordLow.X = Bars.Get(idx).Time;
                    coordLow.Y = Bars.Get(idx).Low;
                    coordLow.Valid = true;

                    pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordHigh);
                    rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);

                    if (rectPoint.Contains(pnt))
                    {
                        retCoord = coordHigh;
                        DrawSnap(graphics, rectPoint, color);
                        break;
                    }
                    else
                    {
                        pntTest = chartHelper.CalcCanvasCoordFromChartCoords(coordLow);
                        rectPoint = new Rectangle(pntTest.X - (size / 2), pntTest.Y - (size / 2), size, size);
                        if (rectPoint.Contains(pnt))
                        {
                            retCoord = coordLow;
                            DrawSnap(graphics, rectPoint, color);
                            break;
                        }
                    }
                }

                return retCoord;
            }

            public void DrawSnap(Graphics graphics, Rectangle rect, Color color)
            {
                if (graphics == null)
                    return;

                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;

                graphics.FillRectangle(new SolidBrush(color), rect);

                graphics.SmoothingMode = oldSmoothingMode;
            }
            #endregion

            #region Trend Lines
            public bool UpTrend(Gline gline)
            {
                if (gline.ChartP3.Y > gline.ChartP1.Y)
                    return true;

                return false;
            }

            // _e_
            public double Slope(Gline gline)
            {
                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP1);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP3);
                LineEx RTL = new LineEx(P1, P3);
                return RTL.LineSlope();
            }

            public List<LineEx> CreateTrendlines(Gline gline)
            {
                string ss = "";

                Point P1 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP1);
                Point P2 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP2);
                Point P3 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP3);
                Point P4 = chartHelper.CalcCanvasCoordFromChartCoords(gline.ChartP4);

                List<LineEx> TrendLines = new List<LineEx>();

                if (P1.X == 0)
                    return TrendLines;

                //if (P1 == P3)
                //    return TrendLines;

                // RTL
                LineEx RTL = new LineEx(P1, P3);
                //RTL.ExtendLine(P4.X);
                TrendLines.Insert(0, RTL);

                return TrendLines;
            }

            #endregion

            #region Drawing Glines

            public void DrawGline(Graphics graphics, Gline gline)
            {
                List<LineEx> TrendLines = CreateTrendlines(gline);
                Draw(graphics, TrendLines, gline.GlineColor, gline.GlineWidth);
            }
            public void DrawGline(Graphics graphics, Gline gline, Color color, int width)
            {
                List<LineEx> TrendLines = CreateTrendlines(gline);
                Draw(graphics, TrendLines, color, width);
            }
            protected void Draw(Graphics graphics, List<LineEx> TrendLines, Color color, int width)
            {
                SmoothingMode oldSmoothingMode = graphics.SmoothingMode;
                graphics.SmoothingMode = SmoothingMode.HighQuality;
                Pen pen = new Pen(color, width);
                for (int i = 0; i < TrendLines.Count; i++)
                    graphics.DrawLine(pen, TrendLines[i].P1, TrendLines[i].P2);

                graphics.SmoothingMode = oldSmoothingMode;
            }
            #endregion

            #region Selection
            public bool IsInLine(Gline gline, Point pnt)
            {
                List<LineEx> TrendLines = CreateTrendlines(gline);

                Pen p = new Pen(Color.Black, 8);
                GraphicsPath pth = new GraphicsPath();

                for (int i = 0; i < TrendLines.Count; i++)
                {
                    pth.Reset();

                    if (TrendLines[i].P1 != TrendLines[i].P2)
                    {
                        pth.AddLine(TrendLines[i].P1, TrendLines[i].P2);
                        pth.Widen(p);

                        if (pth.IsVisible(pnt))
                        {
                            p.Dispose();
                            return true;
                        }
                    }
                }
                p.Dispose();
                return false;
            }

            public Rectangle[] CalcAnchorPoints(Gline gline)
            {
                Point pnt;
                Size sz = new Size(6, 6);
                Rectangle[] rectAnchor = new Rectangle[4];

                List<LineEx> TrendLines = CreateTrendlines(gline);

                //P1
                pnt = new Point(TrendLines[0].P1.X - 3, TrendLines[0].P1.Y - 3);
                rectAnchor[0] = new Rectangle(pnt, sz);

                //P3
                pnt = new Point(TrendLines[0].P1.X - 3, TrendLines[0].P1.Y - 3);
                rectAnchor[1] = new Rectangle(pnt, sz);

                //P3
                pnt = new Point(TrendLines[0].P2.X - 3, TrendLines[0].P2.Y - 3);
                rectAnchor[2] = new Rectangle(pnt, sz);

                return rectAnchor;
            }

            public int IsInAnchorPoint(Rectangle[] rectAnchor, Point pnt)
            {
                int AnchorPointSelected = 0;

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }
                return AnchorPointSelected;
            }

            public int IsInAnchorPoint(Gline gline, Point pnt)
            {
                int AnchorPointSelected = 0;

                if (!gline.IsSelected)
                    return AnchorPointSelected;

                Rectangle[] rectAnchor = CalcAnchorPoints(gline);

                Rectangle rect;
                for (int i = 0; i < 4; i++)
                {
                    rect = Rectangle.Inflate(rectAnchor[i], 4, 4);
                    if (rect.Contains(pnt))
                    {
                        AnchorPointSelected = (i + 1);
                        return AnchorPointSelected;
                    }
                }

                return AnchorPointSelected;
            }

            public void DrawAnchor(Graphics graphics, int point, Color color, bool inflate, Rectangle[] rectAnchor)
            {
                Rectangle rect;

                if (inflate)
                    rect = Rectangle.Inflate(rectAnchor[point - 1], 1, 1);
                else
                    rect = rectAnchor[point - 1];

                if (point < 4)
                    graphics.FillRectangle(new SolidBrush(color), rect);
                else
                    graphics.FillEllipse(new SolidBrush(color), rect);
            }

            public Rectangle[] Select(Graphics graphics, Gline gline, Color anchorColor, Color extensionColor)
            {
                Rectangle[] anchors = CalcAnchorPoints(gline);

                DrawAnchor(graphics, 1, anchorColor, false, anchors);
                DrawAnchor(graphics, 2, anchorColor, false, anchors);
                DrawAnchor(graphics, 3, anchorColor, false, anchors);

                DrawAnchor(graphics, 4, extensionColor, false, anchors);
                gline.IsSelected = true;
                return anchors;
            }

            public void DeSelect(Gline gline)
            {
                gline.IsSelected = false;
                gline.AnchorPointSelected = 0;
            }

            #endregion

            #region Cancel Points
            public void SetCancelPoint(Gline gline, int point)
            {
                if (point == 1) { gline.prevPointCoord = gline.ChartP1; }
                if (point == 2) { gline.prevPointCoord = gline.ChartP2; }
                if (point == 3) { gline.prevPointCoord = gline.ChartP3; }

                gline.CancelPoint = point;
            }
            public void CancelPoint(Gline gline)
            {
                if (gline.CancelPoint == 0)
                    return;

                if (gline.CancelPoint == 1) { gline.ChartP1 = gline.prevPointCoord; }
                if (gline.CancelPoint == 2) { gline.ChartP2 = gline.prevPointCoord; }
                if (gline.CancelPoint == 3) { gline.ChartP3 = gline.prevPointCoord; }
            }
            #endregion
        }
        #endregion

        #region Gline
        [Serializable()]
        public class Gline : ISerializable
        {
            // Private properties:
            private Color _glineColor;

            //Public properties:

            // Serialization properties
            public string GtoolName;      // _e_
            public bool Numbers;   //** palinuro's additions
            public bool Alarm;  //** palinuro's additions
            public int PointsCount;
            public bool ReadyToDraw;
            public chartCoord ChartP1;
            public chartCoord ChartP2;
            public chartCoord ChartP3;
            public chartCoord ChartP4;
            public int GlineWidth;
            public int GlineColorSerialize
            {
                get { return _glineColor.ToArgb(); }
                set { _glineColor = Color.FromArgb(value); }
            }
            // End

            [XmlIgnore()]
            public Color GlineColor
            {
                get { return _glineColor; }
                set { _glineColor = value; }
            }

            [XmlIgnore()]
            [NonSerialized()]
            public bool IsSelected = false;
            [XmlIgnore()]
            [NonSerialized()]
            public int AnchorPointSelected = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public int CancelPoint = 0;
            [XmlIgnore()]
            [NonSerialized()]
            public chartCoord prevPointCoord;

            public Gline()
            {
                PointsCount = 0;
                ReadyToDraw = false;
                Numbers = false; // _Palinuro_
                Alarm = false; // _Palinuro_
            }

            public void ResetPoints()
            {
                PointsCount = 0;
            }

            public void SetPoint(int id, chartCoord coord, bool noCount)
            {
                if (id == 1) ChartP1 = coord;
                if (id == 2) ChartP2 = coord;
                if (id == 3) { ChartP3 = coord; }
                if (id == 4) ChartP4 = coord;

                if (!noCount)
                    PointsCount++;
            }
            public void SetPoint(int id, DateTime barX, double price, bool noCount)
            {
                if (id == 1) { ChartP1.X = barX; ChartP1.Y = price; }
                if (id == 2) { ChartP2.X = barX; ChartP2.Y = price; }
                if (id == 3) { ChartP3.X = barX; ChartP3.Y = price; }
                if (id == 4) { ChartP4.X = barX; ChartP4.Y = price; }

                if (!noCount)
                    PointsCount++;
            }

            #region "Binary Serialization"
            // Used only for Binary Serialization
            public Gline(SerializationInfo info, StreamingContext ctxt)
            {
                //Get the values from info and assign them to the appropriate properties
                GtoolName = (string)info.GetValue("GtoolName", typeof(string));
                Numbers = (bool)info.GetValue("Numbers", typeof(bool));	//**
                Alarm = (bool)info.GetValue("Alarm", typeof(bool));	//**
                PointsCount = (int)info.GetValue("PointsCount", typeof(int));
                ReadyToDraw = (bool)info.GetValue("ReadyToDraw", typeof(bool));
                ChartP1.X = (DateTime)info.GetValue("ChartP1.X", typeof(DateTime));
                ChartP1.Y = (double)info.GetValue("ChartP1.Y", typeof(double));
                ChartP1.Valid = (bool)info.GetValue("ChartP1.Valid", typeof(bool));
                ChartP2.X = (DateTime)info.GetValue("ChartP2.X", typeof(DateTime));
                ChartP2.Y = (double)info.GetValue("ChartP2.Y", typeof(double));
                ChartP2.Valid = (bool)info.GetValue("ChartP2.Valid", typeof(bool));
                ChartP3.X = (DateTime)info.GetValue("ChartP3.X", typeof(DateTime));
                ChartP3.Y = (double)info.GetValue("ChartP3.Y", typeof(double));
                ChartP3.Valid = (bool)info.GetValue("ChartP3.Valid", typeof(bool));
                ChartP4.X = (DateTime)info.GetValue("ChartP4.X", typeof(DateTime));
                ChartP4.Y = (double)info.GetValue("ChartP4.Y", typeof(double));
                ChartP4.Valid = (bool)info.GetValue("ChartP4.Valid", typeof(bool));
                GlineWidth = (int)info.GetValue("GlineWidth", typeof(int));
                GlineColor = (Color)info.GetValue("GlineColor", typeof(Color));
            }

            //Serialization function.
            public void GetObjectData(SerializationInfo info, StreamingContext ctxt)
            {
                //You can use any custom name for your name-value pair. But make sure you
                // read the values with the same name. For ex:- If you write EmpId as "EmployeeId"
                // then you should read the same with "EmployeeId"
                info.AddValue("GtoolName", GtoolName);
                info.AddValue("Numbers", Numbers);  //** tg
                info.AddValue("Alarm", Alarm);    //** tg
                info.AddValue("PointsCount", PointsCount);
                info.AddValue("ReadyToDraw", ReadyToDraw);
                info.AddValue("ChartP1.X", ChartP1.X);
                info.AddValue("ChartP1.Y", ChartP1.Y);
                info.AddValue("ChartP1.Valid", ChartP1.Valid);
                info.AddValue("ChartP2.X", ChartP2.X);
                info.AddValue("ChartP2.Y", ChartP2.Y);
                info.AddValue("ChartP2.Valid", ChartP2.Valid);
                info.AddValue("ChartP3.X", ChartP3.X);
                info.AddValue("ChartP3.Y", ChartP3.Y);
                info.AddValue("ChartP3.Valid", ChartP3.Valid);
                info.AddValue("ChartP4.X", ChartP4.X);
                info.AddValue("ChartP4.Y", ChartP4.Y);
                info.AddValue("ChartP4.Valid", ChartP4.Valid);
                info.AddValue("GlineWidth", GlineWidth);
                info.AddValue("GlineColor", GlineColor);
            }
            #endregion



        }
        #endregion

        #region Methods GLINE
        // .....................    chart_Paint_glines
        public void chart_Paint_glines(object sender, PaintEventArgs e)
        {
            chartHelper.chartControl = ChartControl;

            if (_currentMode == ToolMode.Select)
                return;

            try
            {
                if (_currentMode == ToolMode.Create)
                {
                    if ((_mouseCurrentPos != Point.Empty) || (_currentGline != null))
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = glineLogic.Snap(e.Graphics, coord, _snapColor);

                        if (!_currentGline.ChartP1.Valid)
                            return;

                        _currentGline.SetPoint(3, coord, true);

                        glineLogic.DrawGline(e.Graphics, _currentGline, _drawingColor_glines, 1);
                    }
                }
                else if ((_currentMode == ToolMode.Selected))
                {
                    Rectangle[] anchors = glineLogic.Select(e.Graphics, _currentGline, _anchorColor, _extensionColor_glines);

                    _currentGline.AnchorPointSelected = glineLogic.IsInAnchorPoint(anchors, new Point(_mouseCurrentPos.X, _mouseCurrentPos.Y));
                    if (_currentGline.AnchorPointSelected > 0 && _currentGline.AnchorPointSelected < 4)
                        glineLogic.DrawAnchor(e.Graphics, _currentGline.AnchorPointSelected, _anchorColor, true, anchors);
                    else if (_currentGline.AnchorPointSelected == 4)
                        glineLogic.DrawAnchor(e.Graphics, _currentGline.AnchorPointSelected, _extensionColor_glines, true, anchors);
                }
                else if (_currentMode == ToolMode.Edit)
                {
                    Print("ToolMode.Edit");
                    if ((_mouseCurrentPos != Point.Empty) || (_currentGline != null))
                    {
                        _currentGline.ReadyToDraw = false;

                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(_mouseCurrentPos.X, _mouseCurrentPos.Y);
                        if (!coord.Valid) return;

                        coord = glineLogic.Snap(e.Graphics, coord, _snapColor);
                        Print("ToolMode.Edit _currentGline.AnchorPointSelected " + _currentGline.AnchorPointSelected);

                        if (_currentGline.AnchorPointSelected > 0)
                        {
                            _currentGline.SetPoint(_currentGline.AnchorPointSelected, coord, true);     // _e_
                        }

                        glineLogic.DrawGline(e.Graphics, _currentGline, _drawingColor_glines, 1);
                    }
                }

            }
            catch (Exception) { }
        }

        // .....................    chart_MouseDown_glines
        private void chart_MouseDown_glines(object sender, MouseEventArgs e)
        {
            try
            {
                if (e.Button == MouseButtons.Left)
                {
                    chartHelper.chartControl = ChartControl;
                    if (_currentMode == ToolMode.Create)
                    {
                        if (_currentGline.PointsCount == 0)
                        {
                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = glineLogic.Snap(null, coord, _snapColor);
                            _currentGline.SetPoint(1, coord, false); // Set Point 1

                            _mouseCurrentPos = new Point(e.X, e.Y);
                            DrawMessage("New Gline\r\nClick Point 3:");
                        }
                        else if (_currentGline.PointsCount == 1)
                        {
                            //Print(DateTime.Now.ToShortTimeString() + "=> " + "  _currentGline.PointsCount == 1");

                            chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                            if (!coord.Valid) return;

                            coord = glineLogic.Snap(null, coord, _snapColor);
                            _currentGline.SetPoint(3, coord, false); // Set Point 3

                            _currentGline.ReadyToDraw = true;
                            GlineList.Add(_currentGline);
                            _currentMode = ToolMode.Select;
                            _mouseCurrentPos = Point.Empty;
                            glineLogic.SerializeGlines(GlineList, _fileName);
                            //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);
                            RemoveDrawObject(_msgID);
                        }
                    }
                    else if (_currentMode == ToolMode.Select || _currentMode == ToolMode.Selected)
                    {
                        if (_currentMode == ToolMode.Selected)
                        {
                            if (_currentGline.AnchorPointSelected > 0 && _currentGline.AnchorPointSelected < 4)
                            {
                                DrawMessage("Gline Selected\r\nMove Begin Point and Click:");
                                glineLogic.SetCancelPoint(_currentGline, _currentGline.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                            else if (_currentGline.AnchorPointSelected == 2)
                            {
                                DrawMessage("Gline Selected\r\nMove End Point and Click:");
                                glineLogic.SetCancelPoint(_currentGline, _currentGline.AnchorPointSelected);
                                _currentMode = ToolMode.Edit;
                                return;
                            }
                        }

                        bool noSelection = true;
                        Point testPnt = new Point(e.X, e.Y);

                        for (int i = 0; i < GlineList.Count; i++)
                        {
                            if (glineLogic.IsInLine(GlineList[i], testPnt))
                            {
                                noSelection = false;
                                DrawMessage("Gline Selected\r\n\r\nDelete  = Delete Gline\r\n- / +  = Change Width\r\n *  = Change Color\r\n Alt + n = Toggle Numbers\r\n Alt + a = Toggle Alert");
                                _currentGline = GlineList[i];
                                _currentMode = ToolMode.Selected;
                            }
                        }

                        if ((noSelection) && (_currentMode == ToolMode.Selected))
                        {
                            RemoveDrawObject(_msgID);
                            _currentMode = ToolMode.Select;
                        }

                    }
                    else if (_currentMode == ToolMode.Edit)
                    {
                        chartCoord coord = chartHelper.CalcChartCoordFromCanvasCoord(e.X, e.Y);
                        if (!coord.Valid) return;

                        coord = glineLogic.Snap(null, coord, _snapColor);

                        _currentGline.SetPoint(_currentGline.AnchorPointSelected, coord, true);    // _e_
                        _currentGline.ReadyToDraw = true;
                        glineLogic.DeSelect(_currentGline);
                        _currentMode = ToolMode.Select;
                        glineLogic.SerializeGlines(GlineList, _fileName);
                        //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);
                        RemoveDrawObject(_msgID);
                    }
                }
            }
            catch (Exception) { }
        }

        // .....................    chart_MouseMove_glines
        private void chart_MouseMove_glines(object sender, MouseEventArgs e)
        {
            if (_currentMode == ToolMode.Select)
                return;

            if (((_currentMode == ToolMode.Create) && (_currentGline.PointsCount >= 0)) ||
                (_currentMode == ToolMode.Selected) || (_currentMode == ToolMode.Edit))
            {
                _mouseCurrentPos.X = e.X;
                _mouseCurrentPos.Y = e.Y;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
        }

        // .....................    chart_KeyDown_glines
        private void chart_KeyDown_glines(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Insert)
            {
                _currentGline = new Gline();
                _currentGline.GtoolName = _defaultName_glines;
                _currentGline.GlineColor = _defaultColor;
                _currentGline.GlineWidth = _defaultWidth;
                _currentMode = ToolMode.Create;
                _mouseCurrentPos = Point.Empty;
                DrawMessage("New Gline\r\nClick Point 1:");
            }
            if (e.KeyCode == Keys.Escape)
            {
                RemoveDrawObject(_msgID);

                if (_currentMode == ToolMode.Edit)
                {
                    glineLogic.CancelPoint(_currentGline);
                    _currentGline.ReadyToDraw = true;
                }
                _currentGline = null;
                _currentMode = ToolMode.Select;

                if (ChartControl != null)
                    ChartControl.ChartPanel.Invalidate();
            }
            if (e.KeyCode == Keys.Delete)
            {
                if (e.Control == false)
                {
                    if (_currentMode == ToolMode.Selected)
                    {
                        int idx = GlineList.IndexOf(_currentGline);
                        GlineList.RemoveAt(idx);
                        glineLogic.SerializeGlines(GlineList, _fileName);
                        //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);
                        _currentMode = ToolMode.Select;
                        RemoveDrawObject(_msgID);
                    }
                }
                else
                {
                    DialogResult res = System.Windows.Forms.MessageBox.Show("Are you sure you want to DELETE all Glines ?", "WARNING !!!!", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
                    if (res == DialogResult.No)
                        return;

                    GlineList.Clear();
                    glineLogic.SerializeGlines(GlineList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);

                    _currentMode = ToolMode.Select;
                    if (_currentMode == ToolMode.Selected)
                        RemoveDrawObject(_msgID);

                    if (ChartControl != null)
                        ChartControl.ChartPanel.Invalidate();
                }
            }
            if ((e.KeyCode == Keys.Add) || (e.KeyCode == Keys.Oemplus))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                        _currentGline.GlineWidth = Math.Min(4, _currentGline.GlineWidth + 1);


                    //** tg:
                    if (_currentGline != null)
                    {
                        SetAutoColor_gline(_currentGline);

                        if (changeDefault)
                        {
                            _defaultWidth = _currentGline.GlineWidth;
                            changeDefault = false;
                        }
                    }

                    glineLogic.SerializeGlines(GlineList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);
                }
            }
            // More Width Key
            if ((e.KeyCode == Keys.Subtract) || (e.KeyCode == Keys.Oem1))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                        _currentGline.GlineWidth = Math.Max(1, _currentGline.GlineWidth - 1);

                    glineLogic.SerializeGlines(GlineList, _fileName);
                    //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);
                }
            }
            // Change Gline Color Key
            if ((e.KeyCode == Keys.Multiply) || (e.KeyCode == Keys.Oem6))
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                    {
                        Color backColor = Color.Empty;

                        if (ChartControl != null)
                            backColor = ChartControl.BackColor;

                        try
                        {
                            System.Windows.Forms.ColorDialog colorDialog = new System.Windows.Forms.ColorDialog();
                            colorDialog.AnyColor = true;
                            colorDialog.AllowFullOpen = true;
                            colorDialog.ShowDialog();

                            lock (_currentGline)
                            {
                                if (colorDialog.Color != backColor)
                                    _currentGline.GlineColor = colorDialog.Color;

                                colorDialog.Dispose();

                                glineLogic.SerializeGlines(GlineList, _fileName);
                                //Print(DateTime.Now.ToShortTimeString() + "=> " + glineLogic.GetDebugInfo() + "  CN=" + GlineList.Count);

                                if (ChartControl != null)
                                    ChartControl.ChartPanel.Invalidate();
                            }
                        }
                        catch (StackOverflowException ex)
                        { }

                    }
                }
            }
            // _LT_
            // add / subtract Numbers.
            //if (e.KeyCode == Keys.Divide)			// toggle point 123 labels on the selected channel
            if (e.Alt && e.KeyCode == Keys.N)
            {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                    {
                        _currentGline.Numbers = !_currentGline.Numbers;
                        glineLogic.SerializeGlines(GlineList, _fileName);
                    }
                }
            }
            if (e.KeyCode == Keys.Oem5)
            {

                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                    {
                        changeDefault = !changeDefault;
                    }
                }
            }
            //if (e.KeyCode == Keys.A)		// toggle individual alarm enable on the selected gline
            if (e.Alt && e.KeyCode == Keys.A)
                {
                if (_currentMode == ToolMode.Selected)
                {
                    if (_currentGline != null)
                    {
                        _currentGline.Alarm = !_currentGline.Alarm;
                        glineLogic.SerializeGlines(GlineList, _fileName);
                    }
                }
            }
            e.Handled = true;
        }

                // _LT_begin
        public void SetAutoColor_gline(Gline _currentGline)
        {
            if (_currentGline != null)
            {
                if (autocolor)
                {
                    bool upTrend = glineLogic.UpTrend(_currentGline);
                    if (upTrend)
                        switch (_currentGline.GlineWidth)
                        {
                            case 1: _currentGline.GlineColor = Color.Gray;
                                break;
                            case 2: _currentGline.GlineColor = Color.LightBlue;
                                break;
                            case 3: _currentGline.GlineColor = Color.Blue;
                                break;
                            case 4: _currentGline.GlineColor = Color.ForestGreen;
                                break;
                            case 5: _currentGline.GlineColor = Color.DarkBlue;
                                break;
                        }
                    else switch (_currentGline.GlineWidth)
                        {
                            case 1: _currentGline.GlineColor = Color.IndianRed;
                                break;
                            case 2: _currentGline.GlineColor = Color.MediumOrchid;
                                break;
                            case 3: _currentGline.GlineColor = Color.Red;
                                break;
                            case 4: _currentGline.GlineColor = Color.Purple;
                                break;
                            case 5: _currentGline.GlineColor = Color.DarkRed;
                                break;
                        }
                }
                //  else _currentGline.GlineColor = whatever it was
            }
        }
        #endregion

        #region GLINE ODB
        // .....................    Insert_gline
        public int Insert_gline(Gline gline)
        {
            int ret = Replace_gline(gline);
            return (ret);
        }
        // .....................    Replace_gline
        public int Replace_gline(Gline gline)
        {
            chartCoord ChartP1, ChartP2, ChartP3, ChartP4;

            if (gline.GtoolName == null) gline.GtoolName = _defaultName_glines;
            if (gline.GlineColor == Color.Empty) gline.GlineColor = _drawingColor_glines;
            if (gline.GlineWidth == 0) gline.GlineWidth = _defaultWidth;

            if (gline.PointsCount == 0) return 0;

            int th = chartHelper.CalcTickHeight();

            if (gline.PointsCount == 1)
            {
                TimeSpan t = chartHelper.ConvertIdxToTime(CurrentBar)
                        - chartHelper.ConvertIdxToTime(CurrentBar - 1);
                ChartP3.X = gline.ChartP1.X + t;
                ChartP3.Y = gline.ChartP1.Y + 4 * TickSize;   // _e_
                ChartP3.Valid = true;
                gline.SetPoint(3, ChartP3, false);
            }

            Delete_gline(gline);            // Delete gline if exists
            GlineList = glineLogic.DeserializeGlines(_fileName, Bars.Get(0).Time);
            gline.ReadyToDraw = true;
            GlineList.Add(gline);
            glineLogic.SerializeGlines(GlineList, _fileName);

            return 1;
        }

        // .....................    Update_gline
        public int Update_gline(Gline gline)
        {
            int ret = Replace_gline(gline);
            return (ret);
        }
        // .....................    Delete_gline
        public int Delete_gline(Gline gline)
        {
            if (gline.GtoolName == null) gline.GtoolName = _defaultName_glines;
            GlineList = glineLogic.DeserializeGlines(_fileName, Bars.Get(0).Time);
            for (int i = 0; i < GlineList.Count; i++)
                if (GlineList[i].GtoolName == gline.GtoolName) GlineList.RemoveAt(i);
            glineLogic.SerializeGlines(GlineList, _fileName);
            return 1;
        }
        // .....................    Update_glines_all
        public int Update_glines_all()
        {
            GlineList = glineLogic.DeserializeGlines(_fileName, Bars.Get(0).Time);
            GlineList.Clear();
            glineLogic.SerializeGlines(GlineList, _fileName);
            return 1;
        }

        #endregion GLINE ODB

        // COMMON

        #region Methods COMMON
        // .....................    DrawMessage
        public void DrawMessage(string msg)
        {
            DrawTextFixed(_msgID, msg, TextPosition.TopLeft,
                            Color.BlueViolet, new Font("Arial", 10, FontStyle.Bold), Color.Empty, Color.Empty, 255);
        }

        public void DrawBarNumbers(string text)
        {
            // From BarNumbers indicator
            int offset = 5; // Default setting for Offset
			Color textColor = Color.Gray;
			Placement numberPosition = Placement.Bottom;
			double y;

            if (numberPosition == Placement.Bottom)
                y = (Low[0] - (TickSize * offset));
            else y = (High[0] + (TickSize * offset));
            DrawText("Tag" + CurrentBar, Convert.ToString(CurrentBar), 0, y, textColor);
        }

        // .....................    SelectGtool
        public void chart_KeyDown_SelectGtool(object sender, KeyEventArgs e)
        {
            if (e.Alt && e.KeyCode == Keys.D1)
            {
                Print("Now Set Channel - _changedTool = true");
                _previousTool = _currentTool;
                _currentTool = Gtool.Channel;
                _changedTool = true;
                _fileName = _fileName_channels;
            }
            else if (e.Alt && e.KeyCode == Keys.D2)
            {
                Print("Now Set Grect - _changedTool = true");
                _previousTool = _currentTool;
                _currentTool = Gtool.Grect;
                _changedTool = true;
                _fileName = _fileName_grects;
            }
            else if (e.Alt && e.KeyCode == Keys.D3)
            {
                Print("Now Set Gline - _changedTool = true");
                _previousTool = _currentTool;
                _currentTool = Gtool.Gline;
                _changedTool = true;
                _fileName = _fileName_glines;
            }
            if (e.Alt && e.KeyCode == Keys.D)
            {
                Print("Now kstrength set to Standard Deviation of previous cycle");
                _strengthMode = StrengthMode.regdistance;
            }
            else if (e.Alt && e.KeyCode == Keys.P)
            {
                Print("Now kstrength set to tick force of previous cycle");
                _strengthMode = StrengthMode.pstrength;
            }
            else if (e.Alt && e.KeyCode == Keys.K)
            {
                Print("Now kstrength set to tick force of curren cycle");
                _strengthMode = StrengthMode.kstrength;
            }
            else if (e.Alt && e.KeyCode == Keys.N)
            {
                Print("Now kstrength set to none");
                _strengthMode = StrengthMode.kstrength;
            }
            if (e.Alt && e.KeyCode == Keys.B)
            {
                Print("Toggle Bar Numbers");
                if (_showBarNumbers == true) _showBarNumbers = false;
                else if (_showBarNumbers == false) _showBarNumbers = true;
            }
            if (e.Alt && e.KeyCode == Keys.W)
            {
                Print("Toggle Swing Tags");
                if (_showSwingTags == true) _showSwingTags = false;
                else if (_showSwingTags == false) _showSwingTags = true;
            }
            if (e.Alt && e.KeyCode == Keys.I)
            {
                string msg = "STB_Ktools 0.0.2 2009:03:09 06:08:57 "
                    + "\r\n"
                    + "Copyright (c) 2009 solgracia"
                    + "\r\n"
                    + "Released under the GNU General Public License"
                    + "\r\n"
                    + "This indicator simulates Kool's time and price projections."
                    + "\r\n"
                    + "http://www.mypivots.com/forum/forum.asp?FORUM_ID=26"
                    + "\r\n"
                    + "The code is based on the PP_Channels indicator, part of the JHIndicators package, a remarkable coding achievement."
                    + "\r\n"
                    + "http://www.elitetrader.com/vb/showthread.php?s=e659363d98131d09a36483d3dba21070&threadid=97684&perpage=8&pagenumber=105"
                    + "\r\n"
                    + "Parts of code reflect the version of PP_channels.cs and PP_ChartHelper.cs submitted by palinuro (LostTrader)"
                    + "\r\n"
                    + "http://www.elitetrader.com/vb/showthread.php?s=e659363d98131d09a36483d3dba21070&threadid=97684&perpage=6&pagenumber=165"
                    + "\r\n"
                    + "The swing tags are based on the NinjaPriceAction indicator submitted by TraderGuy"
                    + "\r\n"
                    + "http://www.ninjatrader-support2.com/vb/local_links.php?action=jump&id=92&catid=1"
                    + "\r\n"
                    + "The Bar Numbers are based on the BarNumbers indicator."
                    + "\r\n"
                    + "Mention is deserverd by the regular contributors to the MyPivots voice forum"
                    + "\r\n"
                    + "koolblue, VO, PT, CharterJoe, prestwickdrive, PopStocks, Vast524, JackS65, LordAlfa, bruce"
                    + "";
                DrawMessage(msg);
            }
            if (e.Alt && e.KeyCode == Keys.S)
            {
                string msg = "Tool mode: " + _currentTool
                    + "\r\n"
                    + "Edit Mode: " + _currentMode
                    + "\r\n"
                    + "Strength Mode: " + _strengthMode
                    + "\r\n"
                    + "Strength Multiplier: " + _strengthMultiplier
                    + "\r\n"
                    + "Strength Request: " + _strengthBar
                    + "\r\n"
                    + "Show swing tags: " + _showSwingTags
                    + "\r\n"
                    + "Swing wait: " + swingStrength
                    + "\r\n"
                    + "Bars to start: " + swingLookback
                    + "\r\n"
                    + "Tools folder: " + _dirName
                    + "\r\n"
                    + "NOTE: Currently, switching between gtools requires a connected data source"
                    + "";
                DrawMessage(msg);
            }
            if (e.Alt && e.KeyCode == Keys.H)
            {
                string msg =
                    ">> General settings: "
                    + "\r\n"
                    + "  Alt + b = Toggle Bar Numbers "
                    + "\r\n"
                    + "  Alt + w = Toggle Swing Tags "
                    + "\r\n"
                    + "  Alt + d = set kstrenght to SD "
                    + "\r\n"
                    + "  Alt + p = set kstrenght to tick force of previous cycle "
                    + "\r\n"
                    + "  Alt + k = set kstrenght to tick force of current cycle "
                    + "\r\n"
                    + "  (set tick force threshold in properties panel) "
                    + "\r\n"
                    + "  (set impulse multiplier in properties panel) "
                    + "\r\n"
                    + "  Alt + n = set kstrenght to none "
                    + "\r\n"
                    + ">> Select tool mode: "
                    + "\r\n"
                    + "  Alt + 1 = Set Channel tool mode"
                    + "\r\n"
                    + "  Alt + 2 = Set Grect tool mode"
                    + "\r\n"
                    + "  Alt + 3 = Set Gline tool mode"
                    + "\r\n"
                    + ">> On selected tool mode: "
                    + "\r\n"
                    + "  Insert  = Insert tool "
                    + "\r\n"
                    + "  Ctrl + Delete = Delete all tools "
                    + "\r\n"
                    + ">> On selected tool instance: "
                    + "\r\n"
                    + "  Delete  = Delete tool "
                    + "\r\n"
                    + "  - / +  = Change Width "
                    + "\r\n"
                    + "  *  = Change Color "
                    + "\r\n"
                    + "  Alt + n = Toggle Numbers "
                    + "\r\n"
                    + "  Alt + a = Toggle Alert "
                    + "\r\n"
                    + ">> Alert Mode behavior: "
                    + "\r\n"
                    + "  Channel : cross support line counter trend"
                    + "\r\n"
                    + "  Gline : cross line "
                    + "\r\n"
                    + ">> Escape : Remove this message "
                    + "\r\n"
                    + "";
                DrawMessage(msg);
            }


        }

        #endregion

        #region Properties
        [Category("Parameters")]
        [Description("Tool to create or edit: Channel, Grect, Gline, None")]
        public Gtool Drawtool
        {
            get { return _currentTool; }
            set { _currentTool = value; }
        }
        [Category("Parameters")]
        [Description("Method to calculate price estimation: regdistance, pforce, kformce")]
        public StrengthMode ImpulseMethod
        {
            get { return _strengthMode; }
            set { _strengthMode = value; }
        }
        [Category("Parameters")]
        [Description("Multiply factor for price target estimation")]
        public double ImpulseMultiplier
        {
            get { return _strengthMultiplier; }
            set { _strengthMultiplier = value; }
        }
        [Category("Parameters")]
        [Description("Ratio up/down ticks for kforce price target estimation mode")]
        public double ImpulseThresholdK
        {
            get { return _strengthBar; }
            set { _strengthBar = value; }
        }
        [Category("Parameters")]
        [Description("Bars to wait to confirm swing point")]
        public int SwingMargin
        {
            get { return swingStrength; }
            set { swingStrength = value; }
        }
        [Category("Parameters")]
        [Description("Calculate projections only on recent bars")]
        public bool ShortModeActivate
        {
            get { return _shortMode; }
            set { _shortMode = value; }
        }
        [Category("Parameters")]
        [Description("Bars to calculate projections in short mode")]
        public int ShortModeRange
        {
            get { return _shortRange; }
            set { _shortRange = value; }
        }
        [Category("Parameters")]
        [Description("Show swing tags")]
        public bool ShowSwingTags
        {
            get { return _showSwingTags; }
            set { _showSwingTags = value; }
        }
        [Category("Parameters")]
        [Description("Show bar numbers")]
        public bool ShowBarNumbers
        {
            get { return _showBarNumbers; }
            set { _showBarNumbers = value; }
        }
        
        
        [XmlIgnore()]
        [Description("Default Color")]
        [Browsable(false)]
        [Category("Drawing")]
        public Color DefaultColor
        {
            get { return _defaultColor; }
            set { _defaultColor = value; }
        }
        [Browsable(false)]
        public string DefaultColorSerialize
        {
            get { return NinjaTrader.Gui.Design.SerializableColor.ToString(_defaultColor); }
            set { _defaultColor = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
        }
        [Description("Default Width")]
        [Browsable(false)]
        [Category("Drawing")]
        public int DefaultWidth
        {
            get { return _defaultWidth; }
            set { _defaultWidth = Math.Max(1, Math.Min(4, value)); }
        }
        [Description("Binary Serialization is faster and takes less space, but every time a new script import is made on NT all channels are erased")]
        [Category("General")]
        public bool BinarySerialization
        {
            get { return _binarySerial; }
            set { _binarySerial = value; }
        }
        [XmlIgnore()]
        [Description("Drawing Channel Color")]
        [Category("Drawing")]
        public Color DrawingColor
        {
            get { return _drawingColor_channels; }
            set { _drawingColor_channels = value; }
        }
        [Browsable(false)]
        public string DrawingColorSerialize
        {
            get { return NinjaTrader.Gui.Design.SerializableColor.ToString(_drawingColor_channels); }
            set { _drawingColor_channels = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
        }
        [XmlIgnore()]
        [Description("Anchors Channel Color")]
        [Category("Drawing")]
        public Color AnchorColor
        {
            get { return _anchorColor; }
            set { _anchorColor = value; }
        }
        [Browsable(false)]
        public string AnchorColorSerialize
        {
            get { return NinjaTrader.Gui.Design.SerializableColor.ToString(_anchorColor); }
            set { _anchorColor = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
        }
        [XmlIgnore()]
        [Description("Snap Color")]
        [Category("Drawing")]
        public Color SnapColor
        {
            get { return _snapColor; }
            set { _snapColor = value; }
        }
        [Browsable(false)]
        public string SnapColorSerialize
        {
            get { return NinjaTrader.Gui.Design.SerializableColor.ToString(_snapColor); }
            set { _snapColor = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
        }
        // _LT_begin
        [Description("Initial Alarm on/off for new channels. Cntl-A still toggles individual channel alarm settings.")]
        [Category("Alert")]
        public bool Alarm_Enable
        {
            get { return _initialAlarm; }
            set { _initialAlarm = value; }
        }
        [Description("wave file to use for Alarm, must be in NT sounds directory")]
        [Category("Alert")]
        public string Alarm_sound
        {
            get { return alarm_sound; }
            set { alarm_sound = value; }
        }
        // _LT_end

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private STB_Ktools[] cacheSTB_Ktools = null;

        private static STB_Ktools checkSTB_Ktools = new STB_Ktools();

        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        public STB_Ktools STB_Ktools(Color defaultColor, int defaultWidth)
        {
            return STB_Ktools(Input, defaultColor, defaultWidth);
        }

        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        public STB_Ktools STB_Ktools(Data.IDataSeries input, Color defaultColor, int defaultWidth)
        {
            checkSTB_Ktools.DefaultColor = defaultColor;
            defaultColor = checkSTB_Ktools.DefaultColor;
            checkSTB_Ktools.DefaultWidth = defaultWidth;
            defaultWidth = checkSTB_Ktools.DefaultWidth;

            if (cacheSTB_Ktools != null)
                for (int idx = 0; idx < cacheSTB_Ktools.Length; idx++)
                    if (cacheSTB_Ktools[idx].DefaultColor == defaultColor && cacheSTB_Ktools[idx].DefaultWidth == defaultWidth && cacheSTB_Ktools[idx].EqualsInput(input))
                        return cacheSTB_Ktools[idx];

            STB_Ktools indicator = new STB_Ktools();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.DefaultColor = defaultColor;
            indicator.DefaultWidth = defaultWidth;
            indicator.SetUp();

            STB_Ktools[] tmp = new STB_Ktools[cacheSTB_Ktools == null ? 1 : cacheSTB_Ktools.Length + 1];
            if (cacheSTB_Ktools != null)
                cacheSTB_Ktools.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheSTB_Ktools = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.STB_Ktools STB_Ktools(Color defaultColor, int defaultWidth)
        {
            return _indicator.STB_Ktools(Input, defaultColor, defaultWidth);
        }

        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        public Indicator.STB_Ktools STB_Ktools(Data.IDataSeries input, Color defaultColor, int defaultWidth)
        {
            return _indicator.STB_Ktools(input, defaultColor, defaultWidth);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.STB_Ktools STB_Ktools(Color defaultColor, int defaultWidth)
        {
            return _indicator.STB_Ktools(Input, defaultColor, defaultWidth);
        }

        /// <summary>
        /// Channel Drawing Tool
        /// </summary>
        /// <returns></returns>
        public Indicator.STB_Ktools STB_Ktools(Data.IDataSeries input, Color defaultColor, int defaultWidth)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.STB_Ktools(input, defaultColor, defaultWidth);
        }

    }
}
#endregion
